;; Amsterdam Stock Exchange (AEX) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart amsterdam)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (amsterdam-symbol? symbol)
  (string-suffix? ".AS" symbol))

;; ^AEX
(define-public (yahoo-index-symbol-amsterdam? symbol)
  (string=? "^AEX" symbol))

(symbol-timezone! amsterdam-symbol? (_ "Amsterdam") timezone-europe-cet)
(symbol-timezone! yahoo-index-symbol-amsterdam? (_ "Amsterdam") timezone-europe-cet)
(yahoo-quote-delay! amsterdam-symbol? 15)

;; only the home page for now ...
;;
(weblink-handler! (list amsterdam-symbol? yahoo-index-symbol-amsterdam?)
  (lambda (symbol)
    (list (_ "_AEX Home Page")
	  (_ "Open web browser at the Amsterdam Stock Exchange home page")
	  "http://www.aex.nl")))
