;; Barcelona Stock Exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart barcelona)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (barcelona-symbol? symbol)
  (string-suffix? ".BC" symbol))

(symbol-timezone! barcelona-symbol?  (_ "Barcelona") timezone-europe-cet)
(yahoo-quote-delay! barcelona-symbol? 15)

;; only the home page for now ...
;;
(weblink-handler! barcelona-symbol?
  (lambda (symbol)
    (list (_ "_Barcelona Stock Exchange Home Page")
	  (_ "Open web browser at the Barcelona Stock Exchange home page")
	  (lang-select '(("es" "http://www.borsabcn.es")
			 ("en" "http://www.borsabcn.es/bolsabcn/navegacion.nsf/vweb/p_eng?OpenDocument"))))))
