;; Bilbao Stock Exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart bilbao)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (bilbao-symbol? symbol)
  (string-suffix? ".BI" symbol))

(symbol-timezone! bilbao-symbol? (_ "Bilbao") timezone-europe-cet)
(yahoo-quote-delay! bilbao-symbol? 15)


;; only the home page for now ...
;; haven't found any actual .BI on yahoo except 20.BI index
;;
(weblink-handler! bilbao-symbol?
  (lambda (symbol)
    (list (_ "_Bilbao Stock Exchange Home Page")
	  (_ "Open web browser at the Bilbao Stock Exchange home page")
	  (lang-select
	   '(("en" "http://www.bolsabilbao.es")
	     ("eu" "http://www.bolsabilbao.es/bolsa/eu/html/home-eu.html")
	     ("es" "http://www.bolsabilbao.es/bolsa/es/html/home-es.html")
	     ("fr" "http://www.bolsabilbao.es/bolsa/fr/html/home-fr.html"))))))
