;; Bombay Stock Exchange (BSE) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart bombay)
  #:use-module (srfi srfi-13)
  #:use-module (chart india)  ;; timezone-calcutta
  #:use-module (chart misc)
  #:use-module (chart yahoo))

(define (bombay-symbol? symbol)
  (string-suffix? ".BO" symbol))

;; ^BSESN bse sensitive
(define (yahoo-index-symbol-bombay? symbol)
  (string-prefix? "^BSE" symbol))

(symbol-timezone! bombay-symbol?   	     (_ "Bombay") timezone-calcutta)
(symbol-timezone! yahoo-index-symbol-bombay? (_ "Bombay") timezone-calcutta)
(yahoo-quote-delay! bombay-symbol? 15)


;;-----------------------------------------------------------------------------
;; weblink - BSE company info
;;
;; Eg. http://www.bseindia.com/qresann/comp_info.asp?scrip_cd=532401
;;

(weblink-handler! bombay-symbol?
  (lambda (symbol)
    (list (_ "BSE _Company Information")
	  (_ "Open web browser at the Bombay Stock Exchange page for this company")
	  ;; there's links on this page to results, announcements, quote, etc
	  (string-append "http://www.bseindia.com/qresann/comp_info.asp?scrip_cd="
			 (chart-symbol-sans-dot symbol)))))
