;; Buenos Aires Stock Exchange setups.

;; Copyright 2005, 2006, 2007, 2008, 2009 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart buenosaires)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (buenosaires-symbol? symbol)
  (string-suffix? ".BA" symbol))

;; ^MERV
(define (yahoo-index-symbol-buenosaires? symbol)
  (string-prefix? "^MER" symbol))

(define-public timezone-buenosaires
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Buenos Aires")
		      '("America/Argentina/Buenos_Aires"
			;; first Sun in Oct, to third Sun in Mar, for summer
			;; 2007/2008 onwards
			;; something else in 2009 ...
			;; "ART+3ADT,M10.1.0,M3.3.0"
			)
		      "ART+3"))))

(symbol-timezone! buenosaires-symbol?
		  (_ "Buenos Aires") timezone-buenosaires)
(symbol-timezone! yahoo-index-symbol-buenosaires? 
		  (_ "Buenos Aires") timezone-buenosaires)
(yahoo-quote-delay! buenosaires-symbol? 30)
