;; Colombo Stock Exchange (CSE) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart colombo)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc))


;; ^CSE composite
(define (yahoo-index-symbol-colombo? symbol)
  (string-prefix? "^CSE" symbol))

(define-public timezone-colombo
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Colombo")
		      '("Asia/Colombo"
			;; no daylight savings
			"LKT-5:30")
		      "LKT-5:30"))))

(symbol-timezone! yahoo-index-symbol-colombo? (_ "Colombo") timezone-colombo)


;; only the home page for now ...
;;
(weblink-handler! yahoo-index-symbol-colombo?
  (lambda (symbol)
    (list (_ "_CSE Home Page")
	  (_ "Open web browser at the Colombo Stock Exchange home page")
	  "http://www.cse.lk")))
