;; Datatype setups - generated by make-setups.scm - DO NOT EDIT

;; Copyright 2002, 2003, 2004, 2005, 2006, 2007, 2009 Kevin Ryde
;;
;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(or (datatype-find 'accdist)
    (datatype-new! #:key       'accdist
                   #:name      (_ "Accumulation/Distribution Index")
                   #:units     'accdist
                   #:module    '(chart accdist)))

(or (datatype-find 'adaptive-laguerre)
    (datatype-new! #:key       'adaptive-laguerre
                   #:name      (_ "Adaptive Laguerre Filter")
                   #:units     #f
                   #:module    '(chart adaptive-laguerre)))

(or (datatype-find 'adaptive-laguerre-alpha)
    (datatype-new! #:key       'adaptive-laguerre-alpha
                   #:name      (_ "Adaptive Laguerre Alpha")
                   #:units     'ema-alpha
                   #:priority  -10
                   #:module    '(chart adaptive-laguerre)))

(or (datatype-find 'adx)
    (datatype-new! #:key       'adx
                   #:name      (_ "ADX - Average Directional Index")
                   #:units     'percentage
                   #:module    '(chart adx)))

(or (datatype-find 'aroon)
    (datatype-new! #:key       'aroon
                   #:name      (_ "Aroon")
                   #:units     'percentage-plusorminus100
                   #:module    '(chart aroon)))

(or (datatype-find 'asi)
    (datatype-new! #:key       'asi
                   #:name      (_ "ASI - Accumulative Swing Index")
                   #:units     'accumulative-swing-index
                   #:module    '(chart asi)))

(or (datatype-find 'atr)
    (datatype-new! #:key       'atr
                   #:name      (_ "ATR - Average True Range")
                   #:units     'price
                   #:module    '(chart atr)))

(or (datatype-find 'bollinger)
    (datatype-new! #:key       'bollinger
                   #:name      (_ "Bollinger Bands")
                   #:units     #f
                   #:module    '(chart bollinger)))

(or (datatype-find 'cci)
    (datatype-new! #:key       'cci
                   #:name      (_ "CCI - Commodity Channel Index")
                   #:units     'cci
                   #:module    '(chart cci)))

(or (datatype-find 'chaikin-mf)
    (datatype-new! #:key       'chaikin-mf
                   #:name      (_ "Chaikin Money Flow")
                   #:units     'plus-or-minus-one
                   #:module    '(chart chaikin-mf)))

(or (datatype-find 'chaikin-osc)
    (datatype-new! #:key       'chaikin-osc
                   #:name      (_ "Chaikin Oscillator")
                   #:units     'chaikin-osc
                   #:module    '(chart chaikin-osc)))

(or (datatype-find 'closes)
    (datatype-new! #:key       'closes
                   #:name      (_ "Closes")
                   #:units     #f
                   #:priority  -1000
                   #:module    '(chart closes)))

(or (datatype-find 'cog)
    (datatype-new! #:key       'cog
                   #:name      (_ "Centre of Gravity")
                   #:units     'cog
                   #:module    '(chart cog)))

(or (datatype-find 'coppock)
    (datatype-new! #:key       'coppock
                   #:name      (_ "Coppock Curve")
                   #:units     'coppock
                   #:module    '(chart coppock)))

(or (datatype-find 'darvas)
    (datatype-new! #:key       'darvas
                   #:name      (_ "Darvas Boxes")
                   #:units     #f
                   #:module    '(chart darvas)))

(or (datatype-find 'dema)
    (datatype-new! #:key       'dema
                   #:name      (_ "DEMA - Double EMA")
                   #:units     #f
                   #:priority  -10
                   #:module    '(chart dema)))

(or (datatype-find 'dmi)
    (datatype-new! #:key       'dmi
                   #:name      (_ "DMI - Directional Movement Index")
                   #:units     'dmi
                   #:module    '(chart dmi)))

(or (datatype-find 'donchian)
    (datatype-new! #:key       'donchian
                   #:name      (_ "Donchian Channel")
                   #:units     #f
                   #:module    '(chart donchian)))

(or (datatype-find 'dpo)
    (datatype-new! #:key       'dpo
                   #:name      (_ "DPO - Detrended Price Oscillator")
                   #:units     'price
                   #:module    '(chart dpo)))

(or (datatype-find 'ease)
    (datatype-new! #:key       'ease
                   #:name      (_ "Ease of Movement")
                   #:units     'ease
                   #:module    '(chart ease)))

(or (datatype-find 'elder-power)
    (datatype-new! #:key       'elder-power
                   #:name      (_ "Elder Bull/Bear Power")
                   #:units     'momentum
                   #:module    '(chart elder-power)))

(or (datatype-find 'ema)
    (datatype-new! #:key       'ema
                   #:name      (_ "EMA - Exponential MA")
                   #:units     #f
                   #:priority  10
                   #:module    '(chart ema)))

(or (datatype-find 'ema-2)
    (datatype-new! #:key       'ema-2
                   #:name      (_ "EMA of EMA")
                   #:units     #f
                   #:priority  -10
                   #:module    '(chart ema-2)))

(or (datatype-find 'ema-3)
    (datatype-new! #:key       'ema-3
                   #:name      (_ "EMA of EMA of EMA")
                   #:units     #f
                   #:priority  -10
                   #:module    '(chart ema-3)))

(or (datatype-find 'epma)
    (datatype-new! #:key       'epma
                   #:name      (_ "Endpoint MA")
                   #:units     #f
                   #:module    '(chart epma)))

(or (datatype-find 'fisher)
    (datatype-new! #:key       'fisher
                   #:name      (_ "Fisher Transform")
                   #:units     'fisher
                   #:module    '(chart fisher)))

(or (datatype-find 'force-index)
    (datatype-new! #:key       'force-index
                   #:name      (_ "Force Index")
                   #:units     'force-index
                   #:module    '(chart force-index)))

(or (datatype-find 'fosc)
    (datatype-new! #:key       'fosc
                   #:name      (_ "Forecast Oscillator %F")
                   #:units     'roc
                   #:module    '(chart fosc)))

(or (datatype-find 'frama)
    (datatype-new! #:key       'frama
                   #:name      (_ "FRAMA - Fractal Adaptive MA")
                   #:units     #f
                   #:module    '(chart frama)))

(or (datatype-find 'frama-alpha)
    (datatype-new! #:key       'frama-alpha
                   #:name      (_ "FRAMA alpha")
                   #:units     'ema-alpha
                   #:priority  -10
                   #:module    '(chart frama)))

(or (datatype-find 'frama-dimension)
    (datatype-new! #:key       'frama-dimension
                   #:name      (_ "FRAMA dimension")
                   #:units     'frama-dim
                   #:priority  -10
                   #:module    '(chart frama)))

(or (datatype-find 'gapo)
    (datatype-new! #:key       'gapo
                   #:name      (_ "GAPO")
                   #:units     'gapo
                   #:priority  -10
                   #:module    '(chart gapo)))

(or (datatype-find 'guppy-mma)
    (datatype-new! #:key       'guppy-mma
                   #:name      (_ "Gupply Multiple MA")
                   #:units     #f
                   #:module    '(chart guppy-mma)))

(or (datatype-find 'highs)
    (datatype-new! #:key       'highs
                   #:name      (_ "Highs")
                   #:units     #f
                   #:priority  -1000
                   #:module    '(chart closes)))

(or (datatype-find 'hull-ma)
    (datatype-new! #:key       'hull-ma
                   #:name      (_ "Hull MA")
                   #:units     #f
                   #:module    '(chart hull-ma)))

(or (datatype-find 'hurst-dfa)
    (datatype-new! #:key       'hurst-dfa
                   #:name      (_ "Hurst Exponent - DFA")
                   #:units     'zero-to-one
                   #:priority  -10
                   #:module    '(chart hurst-dfa)))

(or (datatype-find 'hurst-r/s)
    (datatype-new! #:key       'hurst-r/s
                   #:name      (_ "Hurst Exponent - R/S")
                   #:units     'zero-to-one
                   #:priority  -10
                   #:module    '(chart hurst-rs)))

(or (datatype-find 'ichimoku)
    (datatype-new! #:key       'ichimoku
                   #:name      (_ "Ichimoku Kinko Hyo")
                   #:units     #f
                   #:module    '(chart ichimoku)))

(or (datatype-find 'imi)
    (datatype-new! #:key       'imi
                   #:name      (_ "IMI - Intraday Momentum Index")
                   #:units     'percentage
                   #:module    '(chart imi)))

(or (datatype-find 'inertia)
    (datatype-new! #:key       'inertia
                   #:name      (_ "Inertia")
                   #:units     'percentage
                   #:module    '(chart inertia)))

(or (datatype-find 'kama)
    (datatype-new! #:key       'kama
                   #:name      (_ "KAMA - Kaufmann Adaptive MA")
                   #:units     #f
                   #:module    '(chart kama)))

(or (datatype-find 'kama-alpha)
    (datatype-new! #:key       'kama-alpha
                   #:name      (_ "KAMA alpha")
                   #:units     'ema-alpha
                   #:priority  -10
                   #:module    '(chart kama)))

(or (datatype-find 'keltner)
    (datatype-new! #:key       'keltner
                   #:name      (_ "Keltner Channel")
                   #:units     #f
                   #:module    '(chart keltner)))

(or (datatype-find 'kirshenbaum)
    (datatype-new! #:key       'kirshenbaum
                   #:name      (_ "Kirshenbaum Bands")
                   #:units     #f
                   #:module    '(chart kirshenbaum)))

(or (datatype-find 'klinger-volume-force)
    (datatype-new! #:key       'klinger-volume-force
                   #:name      (_ "KVO volume force")
                   #:units     'klinger-volume-force
                   #:priority  -10
                   #:module    '(chart kvo)))

(or (datatype-find 'kvo)
    (datatype-new! #:key       'kvo
                   #:name      (_ "KVO - Klinger Volume Oscillator")
                   #:units     'kvo
                   #:module    '(chart kvo)))

(or (datatype-find 'laguerre)
    (datatype-new! #:key       'laguerre
                   #:name      (_ "Laguerre Filter")
                   #:units     #f
                   #:module    '(chart laguerre)))

(or (datatype-find 'laguerre-LN)
    (datatype-new! #:key       'laguerre-LN
                   #:name      (_ "Laguerre Filter Part")
                   #:units     #f
                   #:priority  -10
                   #:module    '(chart laguerre)))

(or (datatype-find 'linreg-slope)
    (datatype-new! #:key       'linreg-slope
                   #:name      (_ "Linear Regression Slope")
                   #:units     'price-slope
                   #:priority  -10
                   #:module    '(chart linreg)))

(or (datatype-find 'linreg-stderr)
    (datatype-new! #:key       'linreg-stderr
                   #:name      (_ "Linear Regression Stderr")
                   #:units     'price
                   #:priority  -10
                   #:module    '(chart linreg-stderr)))

(or (datatype-find 'lows)
    (datatype-new! #:key       'lows
                   #:name      (_ "Lows")
                   #:units     #f
                   #:priority  -1000
                   #:module    '(chart closes)))

(or (datatype-find 'macd)
    (datatype-new! #:key       'macd
                   #:name      (_ "MACD")
                   #:units     'macd
                   #:module    '(chart macd)))

(or (datatype-find 'mass)
    (datatype-new! #:key       'mass
                   #:name      (_ "MASS Index")
                   #:units     'mass
                   #:module    '(chart mass)))

(or (datatype-find 'median)
    (datatype-new! #:key       'median
                   #:name      (_ "Moving Median")
                   #:units     #f
                   #:priority  -10
                   #:module    '(chart median)))

(or (datatype-find 'median-average)
    (datatype-new! #:key       'median-average
                   #:name      (_ "Median-Average Adaptive")
                   #:units     #f
                   #:module    '(chart median-average)))

(or (datatype-find 'median-average-alpha)
    (datatype-new! #:key       'median-average-alpha
                   #:name      (_ "Median-Average Alpha")
                   #:units     'ema-alpha
                   #:priority  -10
                   #:module    '(chart median-average)))

(or (datatype-find 'mfi)
    (datatype-new! #:key       'mfi
                   #:name      (_ "MFI - Money Flow Index")
                   #:units     'percentage
                   #:module    '(chart mfi)))

(or (datatype-find 'midpoint)
    (datatype-new! #:key       'midpoint
                   #:name      (_ "Midpoint (H+L)/2")
                   #:units     #f
                   #:priority  -1000
                   #:module    '(chart midpoint)))

(or (datatype-find 'momentum)
    (datatype-new! #:key       'momentum
                   #:name      (_ "Momentum")
                   #:units     'momentum
                   #:module    '(chart momentum)))

(or (datatype-find 'natr)
    (datatype-new! #:key       'natr
                   #:name      (_ "NATR - Normalized ATR")
                   #:units     'natr
                   #:module    '(chart natr)))

(or (datatype-find 'negative-volume)
    (datatype-new! #:key       'negative-volume
                   #:name      (_ "NVI - Negative Volume Index")
                   #:units     'negative-volume
                   #:module    '(chart neg-volume)))

(or (datatype-find 'obv)
    (datatype-new! #:key       'obv
                   #:name      (_ "OBV - On-balance Volume")
                   #:units     'obv
                   #:module    '(chart obv)))

(or (datatype-find 'ohlcv)
    (datatype-new! #:key       'ohlcv
                   #:name      #f
                   #:units     'price
                   #:module    '(chart ohlcv)))

(or (datatype-find 'open-interest)
    (datatype-new! #:key       'open-interest
                   #:name      (_ "Open Interest")
                   #:units     'open-interest
                   #:module    '(chart open-interest)))

(or (datatype-find 'opens)
    (datatype-new! #:key       'opens
                   #:name      (_ "Opens")
                   #:units     #f
                   #:priority  -1000
                   #:module    '(chart closes)))

(or (datatype-find 'parabolic-sar)
    (datatype-new! #:key       'parabolic-sar
                   #:name      (_ "Parabolic SAR")
                   #:units     #f
                   #:module    '(chart parabolic-sar)))

(or (datatype-find 'pfe)
    (datatype-new! #:key       'pfe
                   #:name      (_ "PFE - Polarized Fractal Efficiency")
                   #:units     'pfe
                   #:module    '(chart pfe)))

(or (datatype-find 'pgo)
    (datatype-new! #:key       'pgo
                   #:name      (_ "PGO - Pretty Good Oscillator")
                   #:units     'pgo
                   #:module    '(chart pgo)))

(or (datatype-find 'positive-volume)
    (datatype-new! #:key       'positive-volume
                   #:name      (_ "PVI - Positive Volume Index")
                   #:units     'positive-volume
                   #:module    '(chart neg-volume)))

(or (datatype-find 'pvt)
    (datatype-new! #:key       'pvt
                   #:name      (_ "PVT - Price Volume Trend")
                   #:units     'pvt
                   #:module    '(chart pvt)))

(or (datatype-find 'qstick)
    (datatype-new! #:key       'qstick
                   #:name      (_ "Qstick")
                   #:units     'qstick
                   #:module    '(chart qstick)))

(or (datatype-find 'ravi)
    (datatype-new! #:key       'ravi
                   #:name      (_ "RAVI")
                   #:units     'ravi
                   #:module    '(chart ravi)))

(or (datatype-find 'rema)
    (datatype-new! #:key       'rema
                   #:name      (_ "REMA - Regularized EMA")
                   #:units     #f
                   #:module    '(chart rema)))

(or (datatype-find 'roc)
    (datatype-new! #:key       'roc
                   #:name      (_ "ROC - Rate of Change")
                   #:units     'roc
                   #:module    '(chart roc)))

(or (datatype-find 'rsi)
    (datatype-new! #:key       'rsi
                   #:name      (_ "RSI - Relative Strength Index")
                   #:units     'percentage
                   #:module    '(chart rsi)))

(or (datatype-find 'rsquared)
    (datatype-new! #:key       'rsquared
                   #:name      (_ "R-Squared")
                   #:units     'zero-to-one
                   #:module    '(chart rsquared)))

(or (datatype-find 'rvi)
    (datatype-new! #:key       'rvi
                   #:name      (_ "RVI - Relative Volatility Index")
                   #:units     'percentage
                   #:module    '(chart rvi)))

(or (datatype-find 'rwi)
    (datatype-new! #:key       'rwi
                   #:name      (_ "RWI - Random Walk Index")
                   #:units     'rwi
                   #:module    '(chart rwi)))

(or (datatype-find 'sine-ma)
    (datatype-new! #:key       'sine-ma
                   #:name      (_ "Sine Weighted MA")
                   #:units     #f
                   #:priority  -10
                   #:module    '(chart sine-ma)))

(or (datatype-find 'sma)
    (datatype-new! #:key       'sma
                   #:name      (_ "SMA - Simple MA")
                   #:units     #f
                   #:priority  10
                   #:module    '(chart sma)))

(or (datatype-find 'stddev)
    (datatype-new! #:key       'stddev
                   #:name      (_ "Standard Deviation")
                   #:units     'price
                   #:priority  -10
                   #:module    '(chart stddev)))

(or (datatype-find 'stoch-rsi)
    (datatype-new! #:key       'stoch-rsi
                   #:name      (_ "Stochastic RSI")
                   #:units     'zero-to-one
                   #:module    '(chart stoch-rsi)))

(or (datatype-find 'stochastics)
    (datatype-new! #:key       'stochastics
                   #:name      (_ "Stochastics %K/%D")
                   #:units     'percentage
                   #:module    '(chart stochastics)))

(or (datatype-find 'swing-index)
    (datatype-new! #:key       'swing-index
                   #:name      (_ "Swing Index")
                   #:units     'swing-index
                   #:priority  -10
                   #:module    '(chart asi)))

(or (datatype-find 't3)
    (datatype-new! #:key       't3
                   #:name      (_ "T3 Moving Average")
                   #:units     #f
                   #:module    '(chart t3)))

(or (datatype-find 'tdrei)
    (datatype-new! #:key       'tdrei
                   #:name      (_ "TD REI - Range Expansion Index")
                   #:units     'percentage-plusorminus100
                   #:module    '(chart tdrei)))

(or (datatype-find 'tema)
    (datatype-new! #:key       'tema
                   #:name      (_ "TEMA - Triple EMA")
                   #:units     #f
                   #:priority  -10
                   #:module    '(chart tema)))

(or (datatype-find 'tii)
    (datatype-new! #:key       'tii
                   #:name      (_ "Trend Intensity Index")
                   #:units     'percentage
                   #:module    '(chart tii)))

(or (datatype-find 'tma)
    (datatype-new! #:key       'tma
                   #:name      (_ "TMA - Triangular MA")
                   #:units     #f
                   #:priority  -10
                   #:module    '(chart tma)))

(or (datatype-find 'trendscore)
    (datatype-new! #:key       'trendscore
                   #:name      (_ "Trendscore")
                   #:units     'plus-or-minus-10
                   #:module    '(chart trendscore)))

(or (datatype-find 'trix)
    (datatype-new! #:key       'trix
                   #:name      (_ "TRIX")
                   #:units     'price-slope
                   #:module    '(chart trix)))

(or (datatype-find 'tsi)
    (datatype-new! #:key       'tsi
                   #:name      (_ "TSI - True Strength Index")
                   #:units     'percentage-plusorminus100
                   #:module    '(chart tsi)))

(or (datatype-find 'twiggs-mf)
    (datatype-new! #:key       'twiggs-mf
                   #:name      (_ "Twiggs Money Flow")
                   #:units     'plus-or-minus-one
                   #:module    '(chart twiggs-mf)))

(or (datatype-find 'typical-price)
    (datatype-new! #:key       'typical-price
                   #:name      (_ "Typical Price (H+L+C)/3")
                   #:units     #f
                   #:priority  -1000
                   #:module    '(chart typical-price)))

(or (datatype-find 'ulcer)
    (datatype-new! #:key       'ulcer
                   #:name      (_ "Ulcer Index")
                   #:units     'ulcer
                   #:module    '(chart ulcer)))

(or (datatype-find 'ultimate)
    (datatype-new! #:key       'ultimate
                   #:name      (_ "Ultimate Oscillator")
                   #:units     'percentage
                   #:module    '(chart ultimate)))

(or (datatype-find 'vhf)
    (datatype-new! #:key       'vhf
                   #:name      (_ "VHF - Vertical Horizontal Filter")
                   #:units     'vhf
                   #:module    '(chart vhf)))

(or (datatype-find 'vidya)
    (datatype-new! #:key       'vidya
                   #:name      (_ "VIDYA - Variable Index Dynamic")
                   #:units     #f
                   #:module    '(chart vidya)))

(or (datatype-find 'vidya-alpha)
    (datatype-new! #:key       'vidya-alpha
                   #:name      (_ "VIDYA alpha")
                   #:units     'ema-alpha
                   #:priority  -10
                   #:module    '(chart vidya)))

(or (datatype-find 'volr)
    (datatype-new! #:key       'volr
                   #:name      (_ "Volatility Ratio")
                   #:units     'volr
                   #:module    '(chart volr)))

(or (datatype-find 'volume)
    (datatype-new! #:key       'volume
                   #:name      (_ "Volume")
                   #:units     'volume
                   #:module    '(chart volume)))

(or (datatype-find 'vwma)
    (datatype-new! #:key       'vwma
                   #:name      (_ "VWMA - Volume Weighted")
                   #:units     #f
                   #:module    '(chart vwma)))

(or (datatype-find 'weighted-close)
    (datatype-new! #:key       'weighted-close
                   #:name      (_ "Weighted Close (H+L+2*C)")
                   #:units     #f
                   #:priority  -1000
                   #:module    '(chart weighted-close)))

(or (datatype-find 'williams-accdist)
    (datatype-new! #:key       'williams-accdist
                   #:name      (_ "Williams Accumulation/Distribution")
                   #:units     'williams-accdist
                   #:module    '(chart williams-accdist)))

(or (datatype-find 'williams-r)
    (datatype-new! #:key       'williams-r
                   #:name      (_ "Williams %R")
                   #:units     'negative-percentage
                   #:module    '(chart williams-r)))

(or (datatype-find 'wma)
    (datatype-new! #:key       'wma
                   #:name      (_ "WMA - Weighted MA")
                   #:units     #f
                   #:priority  10
                   #:module    '(chart wma)))

(or (datatype-find 'zigzag)
    (datatype-new! #:key       'zigzag
                   #:name      (_ "Zig Zag")
                   #:units     #f
                   #:module    '(chart zigzag)))

(or (datatype-find 'zlema)
    (datatype-new! #:key       'zlema
                   #:name      (_ "ZLEMA - Zero Lag EMA")
                   #:units     #f
                   #:module    '(chart zlema)))

