#!/bin/sh
exec chart -s "$0" "$@"
!#

;; Generate table for ymd->adate code in misc.c.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


;; Usage: guile -s ymd-to-adate.scm
;;


(define-public (set-tm:ymd tm year month day)
  (set-tm:year tm (- year 1900))
  (set-tm:mon  tm (1- month))
  (set-tm:mday tm day))

(let ((tm (gmtime 0))
      (prev-mon   -1))
  (set-tm:ymd tm 1975 3 1)  ;; 1 Mar 1975
  (set-tm:hour tm 12)

  (do ((i 0 (1+ i)))
      ((> i 365))

    (or (= prev-mon (tm:mon tm))
	(display (strftime "\n    /* %B */\n    " tm)))
    (set! prev-mon (tm:mon tm))

    (let ((str (format #f "{~a,~a}," (1+ (tm:mon tm)) (tm:mday tm))))
      (if (> (+ (string-length str) (port-column (current-output-port)))
	     79)
	  (display "\n    "))
      (display str))

    ;; step to next day
    (set-tm:mday tm (1+ (tm:mday tm)))
    (set! tm (cdr (mktime tm "GMT")))))


(exit 0)


;; Local variables:
;; mode: scheme
;; End:
