;; Hong Kong Stock Exchange (HKEX) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart hongkong)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (hongkong-symbol? symbol)
  (or (string-suffix? ".HK" symbol)
      (string-prefix? "^H" symbol)))  ;; ^HSI hang seng index

(define-public timezone-hongkong
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Hong Kong")
		      '("Asia/Hong_Kong"
			;; no daylight savings post 1980
			"HKT-8")
		      "HKT-8"))))

(symbol-timezone! hongkong-symbol? (_ "Hong Kong") timezone-hongkong)
(yahoo-quote-delay! hongkong-symbol? 60)

(weblink-handler! hongkong-symbol?
  (lambda (symbol)
    (list (_ "HKEX _Company Information")
	  (_ "Open web browser at the Hong Kong Stock Exchange page for this company")
	  (string-append "http://www.hkex.com.hk/invest/index.asp?id=company/profile_page_e.asp?WidCoID=0" (chart-symbol-sans-dot symbol) "&WidCoAbbName=&Month=&langcode=e"))))
