;; Jakarta Stock Exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart jakarta)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define (jakarta-symbol? symbol)
  (string-suffix? ".JK" symbol))

;; ^JKSE composite
(define (yahoo-index-symbol-jakarta? symbol)
  (string-prefix? "^JK" symbol))

(define-public timezone-jakarta
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Jakarta")
		      '("Asia/Jakarta"
			;; no daylight savings
			"WIT-7")
		      "WIT-7"))))

(symbol-timezone! jakarta-symbol? (_ "Jakarta") timezone-jakarta)
(symbol-timezone! yahoo-index-symbol-jakarta? (_ "Jakarta") timezone-jakarta)
(yahoo-quote-delay! jakarta-symbol? 10)
