;; Karachi Stock Exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart karachi)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc))


;; ^KSE karachi 100
;;
;; avoid clash with ^KS11 in korea.scm
;;
(define (yahoo-index-symbol-karachi? symbol)
  (string-prefix? "^KSE" symbol))

(define-public timezone-karachi
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Karachi")
		      '("Asia/Karachi"
			;; no daylight savings except 2002 trial
			"PKT-5")
		      "PKT-5"))))

(symbol-timezone! yahoo-index-symbol-karachi? (_ "Karachi") timezone-karachi)


;; only the home page for now ...
;;
(weblink-handler! yahoo-index-symbol-karachi?
  (lambda (symbol)
    (list (_ "_Karachi Stock Exchange Home Page")
	  (_ "Open web browser at the Karachi Stock Exchange home page")
	  "http://www.kse.com.pk")))
