;; Kuala Lumpur Stock Exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart kualalumpur)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (kualalumpur-symbol? symbol) 
  (string-suffix? ".KL" symbol))

;; ^KLSE composite
(define (yahoo-index-symbol-kualalumpur? symbol)
  (string-prefix? "^KL" symbol))

(define-public timezone-kualalumpur
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Kuala Lumpur")
		      '("Asia/Kuala_Lumpur"
			;; no daylight savings
			"MYT-8")
		      "MYT-8"))))

(symbol-timezone! kualalumpur-symbol?
		  (_ "Kuala Lumpur") timezone-kualalumpur)
(symbol-timezone! yahoo-index-symbol-kualalumpur?
		  (_ "Kuala Lumpur") timezone-kualalumpur)
(yahoo-quote-delay! kualalumpur-symbol? 20)

;; only the home page for now ...
;;
(weblink-handler! (list kualalumpur-symbol? yahoo-index-symbol-kualalumpur?)
  (lambda (symbol)
    (list (_ "_Kuala Lumpur Stock Exchange Home Page")
	  (_ "Open web browser at the Kualalumpur Stock Exchange home page")
	  "http://www.klse.com.my")))
