;; London Stock Exchange (LSE) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart london)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (london-symbol? symbol)
  (or (string-suffix? ".L" symbol)
      ;; IOB international order book, etc TPSD.IL
      (string-suffix? ".IL" symbol)))

;; ^FTSE
(define-public (yahoo-index-symbol-london? symbol)
  (string-prefix? "^FT" symbol))

(symbol-timezone! london-symbol?             (_ "London") timezone-london)
(symbol-timezone! yahoo-index-symbol-london? (_ "London") timezone-london)
(yahoo-quote-delay! london-symbol? 20)


;;-----------------------------------------------------------------------------
;; weblink - company info

(weblink-handler! london-symbol?
  (lambda (symbol)
    (list (_ "LSE _Company Information")
	  (_ "Open web browser at the London Stock Exchange page for this company")
	  (string-append "http://www.londonstockexchange.com/en-gb/pricesnews/prices/system/detailedprices.htm?ti=" (chart-symbol-sans-dot symbol)))))
