;; Madrid Stock Exchange setups.

;; Copyright 2005, 2006, 2007, 2008 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart madrid)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (madrid-symbol? symbol)
  (or (string-suffix? ".MA" symbol)   ;; main
      (string-suffix? ".MC" symbol)   ;; CATS
      (string-suffix? ".MF" symbol))) ;; fixed interest

;; ^SMSI
(define (yahoo-index-symbol-madrid? symbol)
  (string-prefix? "^SM" symbol))

(symbol-timezone! madrid-symbol?             (_ "Madrid") timezone-europe-cet)
(symbol-timezone! yahoo-index-symbol-madrid? (_ "Madrid") timezone-europe-cet)
(yahoo-quote-delay! madrid-symbol? 15)


;; only the home page for now ...
;;
(weblink-handler! (list madrid-symbol? yahoo-index-symbol-madrid?)
  (lambda (symbol)
    (list (_ "_Madrid Stock Exchange Home Page")
	  (_ "Open web browser at the Madrid Stock Exchange home page")
	  "http://www.bolsamadrid.es")))
