;; Mexico Stock Exchange (BMV) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart mexico)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (mexico-symbol? symbol)
  (string-suffix? ".MX" symbol))

;; ^MXX ipc
(define-public (yahoo-index-symbol-mexico? symbol)
  (string-prefix? "^MX" symbol))

(define-public timezone-mexicocity
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Mexico City")
		      '("America/Mexico_City"
			;; first Sun in Apr to last Sun in Oct
			"CST+6CDT,M4.1.0,M10.5.0")
		      "CST+6"))))

(symbol-timezone! mexico-symbol? (_ "Mexico City") timezone-mexicocity)
(symbol-timezone! yahoo-index-symbol-mexico? (_ "Mexico City") timezone-mexicocity)
(yahoo-quote-delay! mexico-symbol? 20)


;;-----------------------------------------------------------------------------
;; weblink - only the home page for now ...
;;

(weblink-handler! (list mexico-symbol? yahoo-index-symbol-mexico?)
  (lambda (symbol)
    (list (_ "_BMV Home Page")
	  (_ "Open web browser at the Mexico Stock Exchange home page")
	  "http://www.bmv.com.mx")))
