;; Milan Stock Exchange setups.

;; Copyright 2005, 2006, 2007, 2008 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart milan)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


;; As of March 2007 the http://finance.yahoo.com/exchanges list doesn't
;; include Milan any more, but it still seems to work.


(define (milan-symbol? symbol)
  (string-suffix? ".MI" symbol))

;; ^MIBTEL
(define (yahoo-index-symbol-milan? symbol)   
  (string-prefix? "^MIB" symbol))

(symbol-timezone! milan-symbol? (_ "Milan") timezone-europe-cet)
(symbol-timezone! yahoo-index-symbol-milan? (_ "Milan") timezone-europe-cet)

;; See: http://www.borsaitaliana.it/chisiamo/mercatigestiti/orari/orarionegoziazioni.en.htm
;; pre-open from 8:00, trading until 17:00 main and 17:30 mot, then
;; after-hours 18:00 to 20:30
(yahoo-quote-lock! milan-symbol?
		   #,(hms->seconds 8 0 0) #,(hms->seconds 20 30 0))

(yahoo-quote-delay! milan-symbol? 20)



;; Profile links are based in ISIN, eg IT.MI
;; http://www.borsaitaliana.it/bitApp/scheda.bit?target=StrumentoMTA&isin=IT0001465159&lang=en
