;; On-balance Volume (OBV) indicator.

;; Copyright 2003, 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart obv)
  #:use-module (chart indicator)
  #:use-module (chart misc))


(define (obv-func array prev this)
  (let ((prev-close (array-ref array prev 3))
	(close      (array-ref array this 3)))

    (cond ((> close prev-close)
	   (or (array-ref array this 4) 0))     ;; volume
	  ((< close prev-close)
	   (- (or (array-ref array this 4) 0))) ;; -volume
	  (else
	   0))))

(define-public (obv-series series)
  (accumulation-series series (_ "OBV") obv-datatype obv-func))

(define-public obv-datatype
  (datatype-new!
   #:key    'obv
   #:name   (_ "OBV - On-balance Volume")
   #:units  'obv
   #:manual (_ "CONTEXT(manual-node): On-Balance Volume")
   #:proc   obv-series))
