;; Oslo Stock Exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart oslo)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define (oslo-symbol? symbol) 
  (string-suffix? ".OL" symbol))

;; ^OSEAX
(define (yahoo-index-symbol-oslo? symbol)
  (string-prefix? "^OS" symbol))

(symbol-timezone! oslo-symbol?             (_ "Oslo") timezone-europe-cet)
(symbol-timezone! yahoo-index-symbol-oslo? (_ "Oslo") timezone-europe-cet)
(yahoo-quote-delay! oslo-symbol? 15)


;;-----------------------------------------------------------------------------
;; weblink - Oslo Bors company info
;;
;; Eg. Norwegian
;;
;;     http://www.oslobors.no/ob/aksje_selskapsinfo?languageID=0&p_instrid=ticker.ose.PLUG&p_period=1D&menu2show=1.1.2.4.
;;
;; and English
;;
;;     http://www.oslobors.no/ob/aksje_selskapsinfo?languageID=1&p_instrid=ticker.ose.PLUG&p_period=1D&menu2show=1.1.2.4.
;;

(weblink-handler! oslo-symbol?
  (lambda (symbol)
    (list (_ "Oslo Bors _Company Information")
	  (_ "Open web browser at the Oslo Stock Exchange page for this company")
	  (string-append
	   "http://www.oslobors.no/ob/aksje_selskapsinfo?languageID="
	   (lang-select '(("no" "0")
			  ("en" "1")))
	   "&p_instrid=ticker.ose."
	   (chart-symbol-sans-dot symbol)
	   "&p_period=1D&menu2show=1.1.2.4."))))
