;; US OTC bulletin board setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.



(define-module (chart otcbb)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (otcbb-symbol? symbol)
  (string-suffix? ".OB" symbol))

(symbol-timezone! otcbb-symbol?  (_ "New York") timezone-newyork)
(yahoo-quote-delay! otcbb-symbol? 20)

(weblink-handler! otcbb-symbol?
  (lambda (symbol)
    (list (_ "OTC BB _Company Information")
	  (_ "Open web browser at the OTC bulletin board page for this company")
	  (string-append "http://www.otcbb.com/asp/info_center.asp?symbol=" (chart-symbol-sans-dot symbol)))))
