;; Paris Stock Exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart paris)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define (paris-symbol? symbol)
  (string-suffix? ".PA" symbol))

(define (yahoo-index-symbol-paris? symbol)
  (string-prefix? "^FC" symbol))

(symbol-timezone! paris-symbol?             (_ "Paris") timezone-europe-cet)
(symbol-timezone! yahoo-index-symbol-paris? (_ "Paris") timezone-europe-cet)
(yahoo-quote-delay! paris-symbol? 15)
