;; Phillipine Stock Exchange (PSE) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart phillipine)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc))


;; ^PSI - PSE composite
;;
(define (yahoo-index-symbol-phillipine? symbol)
  (string-prefix? "^PS" symbol))

(define-public timezone-manila
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Manila")
		      '("Asia/Manila"
			;; no daylight savings since 1978
			"PHT-8")
		      "PHT-8"))))

(symbol-timezone! yahoo-index-symbol-phillipine? (_ "Manila")
		  timezone-manila)


;; only the home page for now ...
;;
(weblink-handler! yahoo-index-symbol-phillipine?
  (lambda (symbol)
    (list (_ "CONTEXT(phillipine): _PSE Home Page")
	  (_ "Open web browser at the Phillipine Stock Exchange home page")
	  "http://www.pse.org.ph")))
