;; US pink sheets setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.



(define-module (chart pinksheets)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (pinksheets-symbol? symbol)
  (string-suffix? ".PK" symbol))

(symbol-timezone! pinksheets-symbol? (_ "New York") timezone-newyork)
(yahoo-quote-delay! pinksheets-symbol? 15)

(weblink-handler! pinksheets-symbol?
  (lambda (symbol)
    (list (_ "Pink Sheets _Company Information")
	  (_ "Open web browser at the Pink Sheets page for this company")
	  (string-append "http://www.pinksheets.com/quote/company_profile.jsp?symbol=" (chart-symbol-sans-dot symbol)))))
