;; Prague Stock Exchange (PSE) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart prague)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc))


;; ^PX50
(define (yahoo-index-symbol-prague? symbol)
  (string-prefix? "^PX" symbol))

(symbol-timezone! yahoo-index-symbol-prague? (_ "Prague") timezone-europe-cet)


;; only the home page for now ...
;;
(weblink-handler! yahoo-index-symbol-prague?
  (lambda (symbol)
    (list (_ "CONTEXT(prague): _PSE Home Page")
	  (_ "Open web browser at the Prague Stock Exchange home page")
	  (lang-select '(("cs" "http://www.pse.cz")
			 ("en" "http://www.pse.cz/default.asp?language=english"))))))
