;; Santiago Stock Exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart santiago)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc))


;; ^CLDOW
;; ^CLDOWD
;; ^DWCL
;; ^DWCLD
;; ^DWCLT
;; ^DWCLTD
;;
;; used to have ^IPSA from yahoo, but shows 0.00 as of March 2007
;;
(define (yahoo-index-symbol-santiago? symbol)
  (or (string-prefix? "^CL" symbol)
      (string-prefix? "^DWCL" symbol)))

(define-public timezone-santiago
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Santiago")
		      '("America/Santiago"
			;; second Saturday in Oct to second Saturday in Mar,
			;; at midnight at the end of that day
			"CLT+4CLDT,M10.2.6/24,M3.2.6/24")
		      "CLT+4"))))

(symbol-timezone! yahoo-index-symbol-santiago?
		  (_ "Santiago") timezone-santiago)


;; only the home page for now ...
;;
(weblink-handler! yahoo-index-symbol-santiago?
  (lambda (symbol)
    (list (_ "_Santiago Stock Exchange Home Page")
	  (_ "Open web browser at the Santiago Stock Exchange home page")
	  (lang-select '(("es" "http://www.bolsadesantiago.com")
			 ("en" "http://www.bolsadesantiago.com/english/index.asp"))))))
