;; Sao Paolo Stock Exchange setups.

;; Copyright 2005, 2006, 2007, 2009 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart saopaolo)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (saopaolo-symbol? symbol)
  (string-suffix? ".SA" symbol))

;; ^BVSP bovespa
(define (yahoo-index-symbol-saopaolo? symbol)
  (string-prefix? "^BV" symbol))

(define-public timezone-saopaolo
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Sao Paulo")
		      '("America/Sao_Paulo"
			;; 2nd Sun in Oct to 3rd Sun in Feb, guess for 2008
			;; but something else in 2009 ...
			;; "BRST+3BRDT,M10.2.0,M2.3.0"
			)
		      "BRT+3"))))

(symbol-timezone! saopaolo-symbol?           (_ "Sao Paulo") timezone-saopaolo)
(symbol-timezone! yahoo-index-symbol-saopaolo? (_ "Sao Paulo") timezone-saopaolo)
(yahoo-quote-delay! saopaolo-symbol? 15)

;; only the home page for now ...
;;
(weblink-handler! (list saopaolo-symbol? yahoo-index-symbol-saopaolo?)
  (lambda (symbol)
    (list (_ "_Sao Paolo Stock Exchange Home Page")
	  (_ "Open web browser at the Sao Paolo Stock Exchange home page")
	  "http://www.bovespa.com.br")))
