;; Singapore Stock Exchange (SGX) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart singapore)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define (singapore-symbol? symbol)
  (string-suffix? ".SI" symbol))

(define (yahoo-index-symbol-singapore? symbol)
  (string-prefix? "^ST" symbol)) ;; ^STI straits times

(symbol-timezone! singapore-symbol? (_ "Singapore") timezone-singapore)
(symbol-timezone! yahoo-index-symbol-singapore? (_ "Singapore") timezone-singapore)
(yahoo-quote-delay! singapore-symbol? 20)


;;-----------------------------------------------------------------------------
;; web link - home page only for now
;;

(weblink-handler! (list singapore-symbol? yahoo-index-symbol-singapore?)
  (lambda (symbol)
    (list (_ "SGX _Home Page")
	  (_ "Open web browser at the Singapore Stock Exchange home page")
	  "http://www.sgx.com")))
