;; Stockholm Stock Exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart stockholm)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define (stockholm-symbol? symbol)
  (string-suffix? ".ST" symbol))

(symbol-timezone! stockholm-symbol? (_ "Stockholm") timezone-europe-cet)
(yahoo-quote-delay! stockholm-symbol? 15)

;; http://omxgroup.com/nordicexchange/Abouttrading/tradinginformation/tradinghours/
;; Equities from 9:00, bulletin board reporting to 18:00
;;
(yahoo-quote-lock! stockholm-symbol?
		   #,(hms->seconds 9 0 0) #,(hms->seconds 18 0 0))
