;; Swiss Stock Exchange (SWX) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart switzerland)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (swiss-symbol? symbol)
  (string-suffix? ".SW" symbol))

;; http://au.finance.yahoo.com/intlindices
;; ^SSMI - SMI
;;
;; and note not hitting ^SSEC (shanghai.scm)
;;
(define-public (yahoo-index-symbol-swiss? symbol)
  (string-prefix? "^SSM" symbol))

(symbol-timezone! swiss-symbol? (_ "Switzerland") timezone-europe-cet)
(symbol-timezone! yahoo-index-symbol-swiss? (_ "Switzerland") timezone-europe-cet)
(yahoo-quote-delay! swiss-symbol? 30)


;; swx.com company info pages are based on ISIN codes, not the symbol, would
;; need to extract that to do web links

;; only the home page for now ...
;;
(weblink-handler! (list swiss-symbol? yahoo-index-symbol-swiss?)
  (lambda (symbol)
    (list (_ "_SWX Home Page")
	  (_ "Open web browser at the Swiss Stock Exchange home page")
	  "http://www.swx.com")))
