;; Taiwan Stock Exchange (TSE) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart taiwan)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define (taiwan-symbol? symbol)
  (or (string-suffix? ".TW" symbol)    ;; tse
      (string-suffix? ".TWO" symbol))) ;; tse over-the-counter

(define (yahoo-index-symbol-taiwan? symbol)
  (string-prefix? "^TW" symbol)) ;; ^TWII weighted

(define-public timezone-taiwan
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Taiwan")
		      '("Asia/Taipei"
			;; no daylight savings post 1980
			"CST-8")
		      "CST-8"))))

(symbol-timezone! taiwan-symbol?             (_ "Taiwan") timezone-taiwan)
(symbol-timezone! yahoo-index-symbol-taiwan? (_ "Taiwan") timezone-taiwan)
(yahoo-quote-delay! taiwan-symbol? 20)
