;; Exercise atr.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart atr))


;;
;; true-range-calc-proc
;;

(let* ((data    '((11 9 10) (11 9 10) (12 10 10) (16 14 14) (11 9 9)))
       (want    '(   #f         2          2          6         5))
       (tr-proc (true-range-calc-proc))
       (got     (map-in-order (lambda (elem)
				(apply tr-proc elem))
			      data)))
  (test "true-range-calc-proc" data want got))

(let* ((data    '((11 9 10) (#f #f 10) (#f #f 12)))
       (want    '(      #f          0          2))
       (tr-proc (true-range-calc-proc))
       (got     (map-in-order (lambda (elem)
				(apply tr-proc elem))
			      data)))
  (test "true-range-calc-proc" data want got))



(tests-end)
