;; Test australia.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; source-help
;;

(let* ((symbol "BHP.AX")
       (want   (_ "CONTEXT(manual-node): Australian Stock Exchange"))
       (got    (source-help symbol)))
  (test "source-help" symbol want got))

(let* ((symbol "^AORD")
       (want   (_ "CONTEXT(manual-node): Australian Stock Exchange"))
       (got    (source-help symbol)))
  (test "source-help" symbol want got))

;;
;; yahoo-quote-delay
;;

(define yahoo-quote-delay (@@ (chart yahoo) yahoo-quote-delay))

(let* ((symbol "^AXJO")
       (want   0)
       (got    (begin
		 (symbol-setups symbol)
		 (yahoo-quote-delay symbol ""))))
  (test "yahoo-quote-delay" symbol want got))

(let* ((symbol "BHP.AX")
       (want   (hms->seconds 0 20 0))
       (got    (begin
		 (symbol-setups symbol)
		 (yahoo-quote-delay symbol ""))))
  (test "yahoo-quote-delay" symbol want got))


(tests-end)
