;; Test barchart functions.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart barchart))


;;
;; barchart-dash-frac->decimals
;;

(for-each (lambda (elem)
	    (let* ((str  (first elem))
		   (want (second elem))
		   (got  (barchart-dash-frac->decimals str)))
	      (test "barchart-dash-frac->decimals" str want got)))
	  '(("1" "1")
	    ("-1" "-1")
	    ( "1.5" "1.5")
	    ("7-1" "7.125")
	    ("77-2" "77.25")
	    ("997-3" "997.375")
	    ("11117-4" "11117.50")
	    ("7-5" "7.625")
	    ("7-6" "7.75")
	    ("7-7" "7.875")

	    ("123456-00" "123456.")
	    ("123456-01" "123456.03125")
	    ("123456-08" "123456.25")
	    ("123456-31" "123456.96875")

	    ("99999-000" "99999.")
	    ("99999-010" "99999.03125")
	    ("99999-002" "99999.0078125")
	    ("0-002" "0.0078125")
	    ("99999-005" "99999.015625")
	    ("99999-007" "99999.0234375")
	    ("99999-317" "99999.9921875")
	    ("99999-160" "99999.5")))



(tests-end)
