;; Test bendigo.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; partition-equal-adjacent
;;

(define partition-equal-adjacent (@@ (chart bendigo) partition-equal-adjacent))

(for-each (lambda (elem)
	    (receive-list (lst want)
		elem
	      (let* ((got  (partition-equal-adjacent (lambda (str)
						       (string-ref str 0))
						     lst)))
		(test "partition-equal-adjacent" lst want got))))

	  '(( ()                     () )
	    ( ("a")                  (("a")) )
	    ( ("a" "b")              (("a") ("b")) )
	    ( ("a1" "a2" "b")        (("a1" "a2") ("b")) )
	    ( ("a1" "b" "a2")        (("a1") ("b") ("a2")) )
	    ( ("a1" "a2" "b1" "b2")  (("a1" "a2") ("b1" "b2")) )))

(tests-end)
