;; Test bollinger.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (ice-9 receive)
	     (chart indicator)
	     (chart bollinger))


;;
;; sma/stddev-calc-proc
;;

(set! indicator-minimum-fraction 1)

(let* ((proc (sma/stddev-calc-proc 4))
       (data '(      1       3       1         3         1         3        1))
       (want '((#f #f) (#f #f) (#f #f) (2.0 1.0) (2.0 1.0) (2.0 1.0) (2.0 1.0)))
       (got  (map-in-order (lambda (x)
			     (receive (sma stddev)
				 (proc x)
			       (list sma stddev)))
			   data)))
  (test "sma/stddev-calc-proc" data want got))



(tests-end)
