;; Test casablanca.scm functions.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; casablanca-dividend-parse
;;

(define casablanca-dividend-parse
  (@@ (chart casablanca) casablanca-dividend-parse))

(let* ((str  "something")
       (want "something")
       (got  (casablanca-dividend-parse str)))
  (test "casablanca-dividend-parse" str want got))

(let* ((str  ",")
       (want ",")
       (got  (casablanca-dividend-parse str)))
  (test "casablanca-dividend-parse" str want got))

(let* ((str  "1,23")
       (want '(amount 123 (decimals . 2)))
       (got  (casablanca-dividend-parse str)))
  (test "casablanca-dividend-parse" str want got))

(let* ((str  "1,")
       (want '(amount 1 (decimals . 0)))
       (got  (casablanca-dividend-parse str)))
  (test "casablanca-dividend-parse" str want got))

(let* ((str  ",50")
       (want '(amount 50 (decimals . 2)))
       (got  (casablanca-dividend-parse str)))
  (test "casablanca-dividend-parse" str want got))

(let* ((str  "1,23,45")
       (want "1,23,45")
       (got  (casablanca-dividend-parse str)))
  (test "casablanca-dividend-parse" str want got))


(tests-end)
