;; Test cbot.scm.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; barchart-quote-adate-time
;;

(define barchart-quote-adate-time
  (@@ (chart barchart) barchart-quote-adate-time))

(let ((ymdhms '(2005 1 6  12 0 0)))  ;; Thursday 12:00:00
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhms)

  (let* ((symbol "O.CBOT")
	 (want   (list (ymd->adate 2005 1 6)
		       (hms->seconds 11 35 0)))
	 (got    (begin
(symbol-setups symbol)
(barchart-quote-adate-time symbol))))
    (test "barchart-quote-adate-time" (list symbol ymdhms) want got)))

(let ((ymdhms '(2005 1 6  12 0 5)))  ;; Thursday 12:00:05
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhms)

  (let* ((symbol "O.CBOT")
	 (want   (list (ymd->adate 2005 1 6)
		       (hms->seconds 11 40 0)))
	 (got    (begin
		   (symbol-setups symbol)
		   (barchart-quote-adate-time symbol))))
    (test "barchart-quote-adate-time" (list symbol ymdhms) want got)))

(let ((ymdhms '(2005 1 6  12 0 0)))  ;; Thursday 12:00:00
  (apply fake-localtime-ymdhm! (timezone-europe-cet) ymdhms)

  (let* ((symbol "GBL.CBOT")
	 (want   (list (ymd->adate 2005 1 6)
		       (hms->seconds 11 35 0)))
	 (got    (begin
		   (symbol-setups symbol)
		   (barchart-quote-adate-time symbol))))
    (test "barchart-quote-adate-time" (list symbol ymdhms) want got)))

(let ((ymdhms '(2005 1 6  12 0 5)))  ;; Thursday 12:00:05
  (apply fake-localtime-ymdhm! (timezone-europe-cet) ymdhms)

  (let* ((symbol "GBL.CBOT")
	 (want   (list (ymd->adate 2005 1 6)
		       (hms->seconds 11 40 0)))
	 (got    (begin
		   (symbol-setups symbol)
		   (barchart-quote-adate-time symbol))))
    (test "barchart-quote-adate-time" (list symbol ymdhms) want got)))

(fake-time-end)


(tests-end)
