;; Test curses.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart curses))

;; return true if OBJ is a primitive (ie. C code) procedure
(define (primitive-procedure? obj)
  (and (procedure? obj)
       (not (procedure-source obj))))

;; malloced-steady only if curses.scm using C code
;; mallocated leaks in string ports in guile 1.6 break it on the scheme code
;;
(define malloced-steady-if-C
  (if (primitive-procedure? setupterm)
      malloced-steady
      (lambda (thunk) (thunk))))

;;
;; setupterm
;;

(malloced-steady-if-C
 (lambda ()
   (let* ((args '(1.5))
	  (want #f)
	  (got  (false-if-exception (apply setupterm args))))
     (test "setupterm" args want got))))

(malloced-steady-if-C
 (lambda ()
   (let* ((args '("bogusterminaltype"))
	  (want #t)
	  (got  (->bool (apply setupterm args))))
     (test "setupterm" args want got))))

(malloced-steady-if-C
 (lambda ()
   (let* ((args '("dumb"))
	  (want #f)
	  (got  (apply setupterm args)))
     (test "setupterm" args want got))))

;;
;; tput
;;

(malloced-steady-if-C
 (lambda ()
   (let* ((args '("nosuchcapname"))
	  (want #f)
	  ;; exception with libcurses, false with tput program
	  (got  (false-if-exception (apply tput args))))
     (test "tput" args want got))))



(tests-end)
