;; Test down-cost.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart down-cost))


;;
;; downranges-select
;;

(for-each (lambda (elem)
	    (let* ((args  (first elem))
		   (want (second elem))
		   (got  (apply downranges-select args)))
	      (test "downranges-select" args want got)))
	  '(((((#:lo 1 #:hi 5 #:cost 6000)
	       (#:lo 3 #:hi 5 #:cost 3000))
	      3 5)
	     ((#:lo 3 #:hi 5 #:cost 3000)))

	    ((((#:lo 1 #:hi 5 #:cost 6000)
	       (#:lo 3 #:hi 5 #:cost 3000))
	      1 5)
	     ((#:lo 1 #:hi 5 #:cost 6000)))))

;;
;; for-each-combination
;;

(define for-each-combination (@@ (chart down-cost) for-each-combination))

(for-each (lambda (elem)
	    (let* ((lst  (first elem))
		   (want (second elem))
		   (got  '()))
	      (for-each-combination (lambda (this)
				      (set! got (cons this got)))
				    lst)
	      (set! got (reverse! got))
	      (test "for-each-combination" lst want got)))
	  '(((a)     (() (a)))
	    ((a b)   (() (a) (b) (a b)))
	    ((a b c) (() (a) (b) (a b) (c) (a c) (b c) (a b c)))))

(tests-end)
