;; Test ema-3.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart ema)
	     (chart ema-3))


;;
;; ema-3-omitted
;;

(let ()
  (define (cube x)
    (* x x x))

  ;; return the triangular number of N, ie. N*(N+1)/2
  (define (triangular n)
    (ash (* n (1+ n)) -1))

  (define (ref:ema-3-omitted f i)
    (define total 0)

    (let more ((i (1+ i)))
      (let ((term (* (triangular (1+ i))
		     (expt f i))))
	(set! total (+ total term))

	(if (< (/ term total) 0.0001)
	    (* (cube (- 1 f)) total)

	    (more (1+ i))))))

  (define (=-close? x y)
    (or (<= (abs (- x y)) 0.01)
	(begin
	  (dv x y)
	  #f)))

  (let ((f (ema-count->f 10)))
    (do ((i 1 (1+ i)))
	((> i 50))

      (let* ((want #t)
	     (ref  (ref:ema-3-omitted f i))
	     (cod  (ema-3-omitted f i))
	     (got  (=-close? ref cod)))
	(test "ema-3-omitted" i want got)))))


;;
;; ema-3-warmup-count
;;

(let* ((count 1)
       (want  0)
       (got   (ema-3-warmup-count count)))
  (test "ema-3-warmup-count" count want got))

(let* ((count 2)
       (want  #f)
       (got   (negative? (ema-3-warmup-count count))))
  (test "ema-3-warmup-count positive" count want got))


(tests-end)
