;; Test gethost functions.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart gethost))


;;
;; c-gethost
;;

(let* ((hostname "localhost")
       (want     (gethost hostname))
       (got      (c-gethost hostname)))
  (test "c-gethost" hostname want got))

(let* ((hostname "1.2.3.4")
       (want     (gethost hostname))
       (got      (c-gethost hostname)))
  (test "c-gethost" hostname want got))

(let* ((hostname "localhost")
       (want     (gethost hostname))
       (got      #f))
  (c-main-enq! (lambda ()
		 (set! got (c-gethost hostname))))
  (c-main)
  (test "c-gethost" hostname want got))

(let* ((want     (vector (gethost "1.1.1.1")
			 (gethost "2.2.2.2")
			 (gethost "3.3.3.3")))
       (got      (vector #f #f #f)))
  (c-main-enq! (lambda ()
		 (vector-set! got 0 (c-gethost "1.1.1.1"))))
  (c-main-enq! (lambda ()
		 (vector-set! got 1 (c-gethost "2.2.2.2"))))
  (c-main-enq! (lambda ()
		 (vector-set! got 2 (c-gethost "3.3.3.3"))))
  (c-main)
  (test "c-gethost" "123" want got))

(let* ((want     (vector (gethost "1.1.1.1")
			 (gethost "2.2.2.2")))
       (got      (vector #f #f)))
  (c-main-enq! (lambda ()
		 (vector-set! got 0 (c-gethost "1.1.1.1"))))
  (c-main-enq! (lambda ()
		 (vector-set! got 1 (c-gethost "2.2.2.2"))))
  (c-main)
  (test "c-gethost" "12 again" want got))

(let* ((want     (vector (gethost "5.5.5.5")
			 (gethost "6.6.6.6")))
       (got      (vector #f #f)))
  (c-main-enq! (lambda ()
		 (vector-set! got 0 (c-gethost "5.5.5.5"))))
  (c-main-enq! (lambda ()
		 (vector-set! got 1 (c-gethost "6.6.6.6"))))
  (c-main)
  (test "c-gethost" "56" want got))


(if (defined? 'all-threads)
    (let* ((want 1)
	   (got  (length (remove thread-exited? (all-threads)))))
      (test "remaining all-threads" #f want got)))


(tests-end)

