;; Test Ghana functions.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart ghana))


;;
;; ghana-available-tdate
;;

(define ghana-available-tdate (@@ (chart ghana) ghana-available-tdate))

(let ((ymdhm  '(2005 1 6  8 30)))    ;; Thursday pre
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 4))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 6  9 30)))   ;; Thursday post
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 5))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 7  8 30)))    ;; Friday pre
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 5))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 7  9 30)))   ;; Friday post
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 8  8 30)))    ;; Saturday pre
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 8  9 30)))   ;; Saturday post
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 9  8 30)))    ;; Sunday pre
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 9  9 30)))   ;; Sunday post
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 10  8 30)))   ;; Monday pre
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 10  9 30)))  ;; Monday post
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 11  8 30)))   ;; Tuesday pre
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 11  9 30)))  ;; Tuesday post
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 10))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 12  8 30)))   ;; Wednesday pre
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 10))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 12  9 30)))  ;; Wednesday post
  (apply fake-localtime-ymdhm! (timezone-accra) ymdhm)
  (let ((want (ymd->tdate 2005 1 11))
	(got  (ghana-available-tdate)))
    (test "ghana-available-tdate" ymdhm want got)))


(tests-end)
