;; Test html-form.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; html-tag-parameters-alist
;;

(define html-tag-parameters-alist
  (@@ (chart html-form) html-tag-parameters-alist))

(let* ((str  "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">")
       (want '(("http-equiv" . "Content-Type")
	       ("content"    . "text/html; charset=iso-8859-1")))
       (got  (html-tag-parameters-alist str)))
  (test "html-tag-parameters-alist" str want got))

(let* ((str  "<meta http-equiv='content-Type' content='text/html; charset=iso-8859-1'/>")
       (want '(("http-equiv" . "content-Type")
	       ("content"    . "text/html; charset=iso-8859-1")))
       (got  (html-tag-parameters-alist str)))
  (test "html-tag-parameters-alist" str want got))


(tests-end)
