;; Test https.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart https))


(define (string-or-f? obj)
  (or (string? obj)
      (eq? #f obj)))


;;
;; gnutls-version
;;

(let* ((want #t)
       (got  (string-or-f? (gnutls-version))))
  (test "gnutls-version" "string-or-f?" want got))

;;
;; openssl-version
;;

(let* ((want #t)
       (got  (string-or-f? (openssl-version))))
  (test "openssl-version" "string-or-f?" want got))


(tests-end)
