;; Exercise hurst.scm.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (ice-9 receive)
	     (chart hurst))

;;
;; gamma
;;

(if (defined? 'gamma)
    (let* ((x    5)
	   (want 24.0)
	   (got  (gamma x)))
      (test "gamma" x want got
	    #:compare =-close?)))


;;
;; log-gamma
;;

(let* ((x         5)
       (want-sign 1)
       (want-lgam (log 24.0))
       (want      #t))
  (receive (got-sign got-lgam)
      (log-gamma x)
    (let* ((got (and (equal? want-sign got-sign)
		     (=-close? want-lgam got-lgam))))
      (test "log-gamma" count want got))))



(tests-end)
