;; Test KCBT functions.

;; Copyright 2005, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; daily-prices-available-tdate
;;

(define daily-prices-available-tdate
  (@@ (chart kcbt) daily-prices-available-tdate))

(let ((ymdhm  '(2005 1 6  14 0))) ;; Thursday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 5))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 6  15 0))) ;; Thursday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 7  14 0))) ;; Friday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 7  15 0))) ;; Friday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 8  14 0))) ;; Saturday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 8  15 0))) ;; Saturday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 9  14 0))) ;; Sunday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 9  15 0))) ;; Sunday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 10  14 0))) ;; Monday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 10  15 0))) ;; Monday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 10))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 11  14 0))) ;; Tuesday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 10))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 11  15 0))) ;; Tuesday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 11))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 12  14 0))) ;; Wednesday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 11))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 12  15 0))) ;; Wednesday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 12))
	(got  (daily-prices-available-tdate)))
    (test "daily-prices-available-tdate" ymdhm want got)))


;;
;; daily-volume-available-tdate
;;

(define daily-volume-available-tdate (@@ (chart kcbt) daily-volume-available-tdate))

(let ((ymdhm  '(2005 1 6  17 30))) ;; Thursday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 5))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 6  18 30))) ;; Thursday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 7  17 30))) ;; Friday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 7  18 30))) ;; Friday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 8  17 30))) ;; Saturday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 8  18 30))) ;; Saturday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 9  17 30))) ;; Sunday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 9  18 30))) ;; Sunday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 10  17 30))) ;; Monday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 10  18 30))) ;; Monday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 10))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 11  17 30))) ;; Tuesday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 10))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 11  18 30))) ;; Tuesday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 11))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 12  17 30))) ;; Wednesday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 11))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 12  18 30))) ;; Wednesday
  (apply fake-localtime-ymdhm! (timezone-chicago) ymdhm)
  (let ((want (ymd->tdate 2005 1 12))
	(got  (daily-volume-available-tdate)))
    (test "daily-volume-available-tdate" ymdhm want got)))


;;
;; kcbt-symbol-ensure-yy
;;

(define kcbt-symbol-ensure-yy
  (@@ (chart kcbt) kcbt-symbol-ensure-yy))

(let* ((symbol "KWN5")
       (want   "KWN05")
       (got    (kcbt-symbol-ensure-yy symbol)))
  (test "kcbt-symbol-ensure-yy" symbol want got))

(let* ((symbol "KWN05")
       (want   "KWN05")
       (got    (kcbt-symbol-ensure-yy symbol)))
  (test "kcbt-symbol-ensure-yy" symbol want got))



(tests-end)
