;; Tests for keys.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(need-gtk)
(use-modules (chart extra-glib)
	     (chart keymap))


(define srcdir (getenv "srcdir"))  ;; from the Makefile
(define result 0)

;;
;; procedure-description
;;

(define procedure-description (@@ (chart keys) procedure-description))

(define keymap-entries-count 0)

;; load all modules with keymap-set! calls
(for-each (lambda (filename)
	    (if (string-contains
		 (call-with-input-file filename read-string-to-eof)
		 "keymap-set!")
		(resolve-interface
		 (list 'chart (string->symbol (basename filename ".scm"))))))
	  (directory-files (g-build-filename srcdir "..") #t
			   (lambda (path)
			     (string-suffix? ".scm" path))))

(define (check-key keymap key proc)
  (set! keymap-entries-count (1+ keymap-entries-count))
  (if (string-null? (procedure-description proc))
      (begin
	(set! result 1)
	(format #t "No procedure description: ~s\n  ~s ~s\n"
		(keymap-name keymap) key proc))))

(define (check-keymap keymap)
  (for-each (lambda (elem)
	      (check-key keymap (car elem) (cdr elem)))
	    (keymap-alist keymap)))

(for-each check-keymap keymap-list)

(format #t "total ~a keymap extries\n" keymap-entries-count)
(exit result)
