;; Test latest.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; string-decimals-limit
;;

(define string-decimals-limit (@@ (chart latest) string-decimals-limit))

(for-each (lambda (elem)
	    (receive-list (str limit want)
		elem
	      (let* ((got (string-decimals-limit str limit)))
		(test "string-decimals-limit" (list str limit) want got))))
	  '(("123"     #f  0)
	    ("123."    #f  0)
	    ("123.0"   #f  1)
	    ("123.5"   #f  1)
	    ("123.00"  #f  2)
	    ("123.50"  #f  2)
	    ("123.05"  #f  2)
	    ("123.000" #f  3)
	    ("123.500" #f  3)
	    ("123.050" #f  3)
	    ("123.005" #f  3)

	    ("123"     1   0)
	    ("123."    1   0)
	    ("123.0"   1   1)
	    ("123.5"   1   1)
	    ("123.00"  1   1)
	    ("123.50"  1   1)
	    ("123.05"  1   2)
	    ("123.500" 1   1)
	    ("123.050" 1   2)
	    ("123.005" 1   3)

	    ("123"     2   0)
	    ("123."    2   0)
	    ("123.0"   2   1)
	    ("123.5"   2   1)
	    ("123.00"  2   2)
	    ("123.50"  2   2)
	    ("123.05"  2   2)
	    ("123.500" 2   2)
	    ("123.050" 2   2)
	    ("123.005" 2   3)

	    ("123"     3   0)
	    ("123."    3   0)
	    ("123.0"   3   1)
	    ("123.5"   3   1)
	    ("123.00"  3   2)
	    ("123.50"  3   2)
	    ("123.05"  3   2)
	    ("123.500" 3   3)
	    ("123.050" 3   3)
	    ("123.005" 3   3)

	    ("123.005" 5   3)))

(tests-end)
