;; Exercise linreg.scm.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (ice-9 receive)
	     (chart linreg))

;;
;; xx2-calc
;;

(define xx2-calc (@@ (chart linreg) xx2-calc))

(define (sum-squares lst)
  (apply + (map square lst)))

(for-each (lambda (elem)
	    (let* ((n    (first elem))
		   (lst  (second elem))
		   (want (exact->inexact (* 0.5 (sum-squares lst))))
		   (got  (xx2-calc n)))
	      (test "xx2-calc" (list n lst) want got)))
	  '((0 ())
	    (1 (0))
	    (2 (-1 1))
	    (3 (-2 0 2))
	    (4 (-3 -1 1 3))
	    (5 (-4 -2 0 2 4))
	    (6 (-5 -3 -1 1 3 5))
	    (7 (-6 -4 -2 0 2 4 6))
	    (8 (-7 -5 -3 -1 1 3 5 7))))

;;
;; linreg-calc-proc
;;

(for-each (lambda (elem)
	    (let* ((n    (first elem))
		   (data (second elem))
		   (want (third elem))
		   (proc (linreg-calc-proc n))
		   (got  (map-in-order (lambda (x)
					 (receive (a b)
					     (proc x)
					   (list a b)))
				       data)))
	      (test "linreg-calc-proc" (list n data) want got)))
	  '((3 ( 1       1       1         1         1         1         1)
	       ((#f #f) (#f #f) (1.0 0.0) (1.0 0.0) (1.0 0.0) (1.0 0.0) (1.0 0.0)))

	    (5 ( 1.0     2.0     3.0     4.0       5.0       6.0       7.0)
	       ((#f #f) (#f #f) (#f #f) (4.0 1.0) (5.0 1.0) (6.0 1.0) (7.0 1.0)))

	    (3 ( 9       3       9         3         9         3         9)
	       ((#f #f) (#f #f) (7.0 0.0) (5.0 0.0) (7.0 0.0) (5.0 0.0) (7.0 0.0)))

	    (4 ( 0       2       4         6         8         10         12)
	       ((#f #f) (#f #f) (4.0 2.0) (6.0 2.0) (8.0 2.0) (10.0 2.0) (12.0 2.0)))))


(tests-end)
