;; Test ljubljana.scm functions.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; change%->change
;;

(define change%->change (@@ (chart ljubljana) change%->change))

(for-each (lambda (elem)
	    (let* ((args   (first elem))
		   (want   (second elem))
		   (got    (apply change%->change args)))
	      (test "change%->change" args want got)))
	  '((("150.00" "50")    "50.00")
	    (("2400.0" "20")   "400.0")
	    (("300"    "50")   "100.")))

;;
;; symbol-timezone
;;

(let* ((symbol "FOO.LJ")
       (want   (timezone-europe-cet))
       (got    (symbol-timezone symbol)))
  (test "symbol-timezone" symbol want got))

(let* ((symbol "^BAR.LJ")
       (want   (timezone-europe-cet))
       (got    (symbol-timezone symbol)))
  (test "symbol-timezone" symbol want got))

(symbol-setups "^GSPC")

(let* ((symbol "^SBI20.LJ")
       (want   (timezone-europe-cet))
       (got    (symbol-timezone symbol)))
  (test "symbol-timezone, after yahoo" symbol want got))



(tests-end)
