;; Exercise mfi.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart mfi))


;;
;; percent-posneg-calc-proc
;;

(let* ((count 4)
       (data  '( 0  0  0  0))
       (want  '(#f #f 50 50))
       (proc  (percent-posneg-calc-proc count))
       (got   (map proc data)))
  (test "percent-posneg-calc-proc" (list count data) want got))

(let* ((count 4)
       (data  '( 1  2     3     4))
       (want  '(#f #f 100.0 100.0))
       (proc  (percent-posneg-calc-proc count))
       (got   (map proc data)))
  (test "percent-posneg-calc-proc" (list count data) want got))

(let* ((count 4)
       (data  '( 1  1   -2    4    9))
       (want  '(#f #f 50.0 75.0 87.5))
       (proc  (percent-posneg-calc-proc count))
       (got   (map proc data)))
  (test "percent-posneg-calc-proc" (list count data) want got))

(let* ((count 4)
       (data  '(-1 -1    2   -4   -9))
       (want  '(#f #f 50.0 25.0 12.5))
       (proc  (percent-posneg-calc-proc count))
       (got   (map proc data)))
  (test "percent-posneg-calc-proc" (list count data) want got))


(tests-end)
