;; Test MLC functions.

;; Copyright 2005, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; mlc-available-tdate
;;

(define mlc-available-tdate (@@ (chart mlc) mlc-available-tdate))

(let ((ymdhm  '(2005 1 6  12 0))) ;; Thursday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 4))
	(got  (mlc-available-tdate)))
    (test "mlc-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 7  12 0))) ;; Friday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 5))
	(got  (mlc-available-tdate)))
    (test "mlc-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 8  12 0))) ;; Saturday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (mlc-available-tdate)))
    (test "mlc-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 9  12 0))) ;; Sunday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (mlc-available-tdate)))
    (test "mlc-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 10  12 0))) ;; Monday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (mlc-available-tdate)))
    (test "mlc-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 11  12 0))) ;; Tuesday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (mlc-available-tdate)))
    (test "mlc-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 12  12 0))) ;; Wednesday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 10))
	(got  (mlc-available-tdate)))
    (test "mlc-available-tdate" ymdhm want got)))

;;
;; mlc-symbol-fund
;;

(define mlc-symbol-fund (@@ (chart mlc) mlc-symbol-fund))

(let* ((symbol "Foo Bar,Quux Xyzzy.MLC")
       (want   "Foo Bar")
       (got    (mlc-symbol-fund symbol)))
  (test "mlc-symbol-fund" symbol want got))

;;
;; mlc-symbol-product
;;

(define mlc-symbol-product (@@ (chart mlc) mlc-symbol-product))

(let* ((symbol "Foo Bar,Quux Xyzzy.MLC")
       (want   "Quux Xyzzy")
       (got    (mlc-symbol-product symbol)))
  (test "mlc-symbol-product" symbol want got))


(tests-end)
