;; Exercise momentum.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart momentum))


;;
;; momentum-series
;;

(let* ((data        (array-from 0  10 30))
       (want        (array-from 1     20))
       (got-series  (momentum-series (series-new #:array data) 1))
       (got         (series-array got-series -99 99)))
  (test "momentum-series" data want got))

(let* ((data        (array-from 0  10 #f 30))
       (want        (array-from 1     #f 20))
       (got-series  (momentum-series (series-new #:array data) 1))
       (got         (series-array got-series -99 99)))
  (test "momentum-series" data want got))

(let* ((data        (array-from 0  10 #f 30))
       (want        (array-from 1     #f 20))
       (got-series  (momentum-series (series-new #:array data) 1))
       (got         (begin
		      (series-array got-series 2 2)
		      (series-array got-series -99 99))))
  (test "momentum-series" data want got))



(tests-end)
