;; Test ohlcv.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; datatype-closes-apply-arg
;;

(let* ((want   '(3))
       (got    (datatype-closes-apply-arg datatype-ohlcv)))
  (test "datatype-closes-apply-arg" datatype-ohlcv want got))

;;
;; datatype-ohlcv datatype-reduce-proc
;;

(let* ((a    #2((2 5 1 3 123)))
       (red  (datatype-reduce-proc datatype-ohlcv))
       (want a)
       (got  (red a noop)))
  (test "ohlcv reduce null" a want got))

(let* ((a    #2((2 5 1 3 123)
		(4 6 2 5 456)))
       (red  (datatype-reduce-proc datatype-ohlcv))
       (want a)
       (got  (red a noop)))
  (test "ohlcv reduce null" a want got))

(let* ((a    #2((2 5 1 3 123)
		(4 6 2 5 456)))
       (red  (datatype-reduce-proc datatype-ohlcv))
       (want #2((2 6 1 5 579)))
       (got  (red a (lambda (i) (quotient i 2)))))
  (test "ohlcv reduce null" a want got))

(let* ((a    #2((2 5 1 3 123)
		(4 6 2 5 #f)))
       (red  (datatype-reduce-proc datatype-ohlcv))
       (want #2((2 6 1 5 123)))
       (got  (red a (lambda (i) (quotient i 2)))))
  (test "ohlcv reduce null" a want got))


;;
;; datatype-ohlcv datatype-reduce-proc, with open interest
;;

(let* ((a    #2((2 5 1 3 123 456)))
       (red  (datatype-reduce-proc datatype-ohlcv))
       (want a)
       (got  (red a noop)))
  (test "ohlcvi reduce null" a want got))

(let* ((a    #2((2 5 1 3 123 999)
		(4 6 2 5 456 888)))
       (red  (datatype-reduce-proc datatype-ohlcv))
       (want a)
       (got  (red a noop)))
  (test "ohlcvi reduce null" a want got))

(let* ((a    #2((2 5 1 3 123 999)
		(4 6 2 5 456 888)))
       (red  (datatype-reduce-proc datatype-ohlcv))
       (want #2((2 6 1 5 579 888)))
       (got  (red a (lambda (i) (quotient i 2)))))
  (test "ohlcvi reduce null" a want got))

(let* ((a    #2((2 5 1 3 123 999)
		(4 6 2 5 #f  #f)))
       (red  (datatype-reduce-proc datatype-ohlcv))
       (want #2((2 6 1 5 123 999)))
       (got  (red a (lambda (i) (quotient i 2)))))
  (test "ohlcvi reduce null" a want got))




(tests-end)
