;; Check chart.omf.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;; skip if scrollkeeper-install not available
(if (eqv? 127 (status:exit-val
	       (system "scrollkeeper-install >/dev/null 2>&1")))
    (begin
      (display "  scrollkeeper-install program not available\n")
      (exit 77)))


(c-atexit (lambda ()
	    (system "rm -r omf.out omf.err omf-testdir")))

(let ((want 0)
      (got  (status:exit-val
	     (system "scrollkeeper-install -v -p omf-testdir ../doc/chart.omf \
                          >omf.out 2>omf.err"))))

  ;; show output only on error, the normal output is only confusing
  (if (not (eqv? got want))
      (begin
	(system "cat omf.out")
	(system "cat omf.err")))

  (test "scrollkeeper-install" "exit status" want got))

(tests-end)
