;; Exercise roc.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart roc))


;;
;; roc-calc-proc
;;

(let* ((count       3)
       (proc        (roc-calc-proc count))
       (data        '(1 2 4 8 16))
       (want        '(#f #f #f 700.0 700.0))
       (got         (map-in-order proc data)))
  (test "roc-calc-proc" (list count data) want got))

;;
;; roc-series
;;

(let* ((data        (array-from 0  1 2))
       (want        (array-from 1    100.0))
       (got-series  (roc-series (series-new #:array data) 1))
       (got         (series-array got-series -99 99)))
  (test "roc-series" data want got))

(let* ((data        (array-from 0  1 #f 2))
       (want        (array-from 1    #f 100.0))
       (got-series  (roc-series (series-new #:array data) 1))
       (got         (series-array got-series -99 99)))
  (test "roc-series" data want got))

(let* ((data        (array-from 0  1 #f 2))
       (want        (array-from 1    #f 100.0))
       (got-series  (roc-series (series-new #:array data) 1))
       (got         (begin
		      (series-array got-series 2 2)
		      (series-array got-series -99 99))))
  (test "roc-series" data want got))



(tests-end)
