;; Exercise rsi.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart rsi))


;;
;; rsi-calc-proc
;;

(let* ((count 3)
       (data  '( 7  7  7  7  7  7  7))
       (want  '(#f #f #f #f 50 50 50))
       (proc  (rsi-calc-proc count))
       (got   (map proc data)))
  (test "rsi-calc-proc" (list count data) want got))

(let* ((count 3)
       (data  '( 3  7  8 10    13    17    22))
       (want  '(#f #f #f #f 100.0 100.0 100.0))
       (proc  (rsi-calc-proc count))
       (got   (map proc data)))
  (test "rsi-calc-proc" (list count data) want got))

;;
;; rsi-calc-proc - cutler
;;

(let* ((count 4)
       (data  '( 7  8  9    7   11   20))
       (want  '(#f #f #f 50.0 75.0 87.5))
       (proc  (rsi-calc-proc count #t))
       (got   (map proc data)))
  (test "rsi-calc-proc cutler" (list count data) want got))

(let* ((count 4)
       (data  '( 7  6  5    7    3   -6))
       (want  '(#f #f #f 50.0 25.0 12.5))
       (proc  (rsi-calc-proc count #t))
       (got   (map proc data)))
  (test "rsi-calc-proc cutler" (list count data) want got))

;;
;; rsi-series
;;

(let* ((count      3)
       (data       (array-from 0  #f #f #f #f #f #f))
       (want       (array-from 0  #f #f #f #f #f #f))
       (got-series (rsi-series (series-new #:array data) count))
       (got        (series-array got-series -99 99)))
  (test "rsi-series" (list count data) want got))

(let* ((count      3)
       (data       (array-from 0  7   7  7  7  7  7 #f #f))
       (want       (array-from 0  #f #f #f #f 50 50 #f #f))
       (got-series (rsi-series (series-new #:array data) count))
       (got        (series-array got-series -99 99)))
  (test "rsi-series" (list count data) want got))

(let* ((count      3)
       (data       (array-from 0  5   7  8 10    13 #f    17 #f    22))
       (want       (array-from 0  #f #f #f #f 100.0 #f 100.0 #f 100.0))
       (got-series (rsi-series (series-new #:array data) count))
       (got        (series-array got-series -99 99)))
  (test "rsi-series" (list count data) want got))

;;
;; rsi-series - cutler
;;

(let* ((count      4)
       (data       (array-from 0   7  8  9 #f    7   11   20))
       (want       (array-from 0  #f #f #f #f 50.0 75.0 87.5))
       (got-series (rsi-series (series-new #:array data) count #t))
       (got        (series-array got-series -99 99)))
  (test "rsi-series cutler" (list count data) want got))

(let* ((count      4)
       (data       (array-from 0   7  6 #f  5    7    3   -6))
       (want       (array-from 0  #f #f #f #f 50.0 25.0 12.5))
       (got-series (rsi-series (series-new #:array data) count #t))
       (got        (series-array got-series -99 99)))
  (test "rsi-series cutler" (list count data) want got))



(tests-end)
