;; Exercise rsquared.scm.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;; Return the triangular number of N, ie. 1+2+...+N, which is N*(N+1)/2.
;;
(define (triangular n)
  (ash (* n (1+ n)) -1))


;;
;; yfactor
;;

(define yfactor (@@ (chart rsquared) yfactor))

(define (ref:yfactor n)
  (/ 1.0 (max 1 (- (* n (apply + (map square (iota n 1))))
		   (square (triangular n))))))

(do ((n 0 (1+ n)))
    ((> n 100))
  (let* ((want  (ref:yfactor n))
	 (got   (yfactor n)))
    (test "yfactor" n want got)))


(tests-end)
