;; Test sicom.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; daily-mung-month-str
;;

(define daily-mung-month-str (@@ (chart sicom) daily-mung-month-str))

(let* ((str  "J/M 06")
       (want "JFM 06")
       (got  (daily-mung-month-str str)))
  (test "sfe-available-tdate" str want got))

(let* ((str  "MAY05")
       (want "MAY 05")
       (got  (daily-mung-month-str str)))
  (test "sfe-available-tdate" str want got))

;;
;; symbol-timezone
;;

(let* ((symbol "RS.SICOM")
       (want   (timezone-singapore))
       (got    (symbol-timezone symbol)))
  (test "symbol-timezone" symbol want got))

(let* ((symbol "TF AMJ 08.SICOM")
       (want   (timezone-singapore))
       (got    (symbol-timezone symbol)))
  (test "symbol-timezone" symbol want got))


(tests-end)
