;; Exercise sma.scm.

;; Copyright 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart sma))


;;
;; sma-calc-proc
;;

(for-each (lambda (elem)
	    (let* ((N       (first elem))
		   (initial (second elem))
		   (proc    (sma-calc-proc N initial))
		   (data    (third elem))
		   (want    (fourth elem))
		   (got     (map-in-order proc data)))
	      (test "sma-calc-proc" (list N initial data) want got)))
	  '((3 ()
	       (1.0 1.0 1.0 1.0 4.0 4.0 4.0 4.0 1.0 1.0 1.0 1.0)
	       ( #f  #f 1.0 1.0 2.0 3.0 4.0 4.0 3.0 2.0 1.0 1.0))

	    (3 (1.0)
	       (1.0 1.0 1.0 4.0 4.0 4.0 4.0 1.0 1.0 1.0 1.0)
	       ( #f 1.0 1.0 2.0 3.0 4.0 4.0 3.0 2.0 1.0 1.0))

	    (3 (1.0 1.0)
	       (1.0 1.0 4.0 4.0 4.0 4.0 1.0 1.0 1.0 1.0)
	       (1.0 1.0 2.0 3.0 4.0 4.0 3.0 2.0 1.0 1.0))

	    (3 (1.0 1.0 1.0)
	       (1.0 4.0 4.0 4.0 4.0 1.0 1.0 1.0 1.0)
	       (1.0 2.0 3.0 4.0 4.0 3.0 2.0 1.0 1.0))

	    (3 (1.0 1.0 1.0 1.0 4.0)
	       (4.0 4.0 4.0 1.0 1.0 1.0 1.0)
	       (3.0 4.0 4.0 3.0 2.0 1.0 1.0))))


(tests-end)
