;; Exercise tma.scm.

;; Copyright 2004, 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart tma))


;;
;; tma-factors
;;

(define tma-factors (@@ (chart tma) tma-factors))

(let* ((count 1)
       (want  '(1))
       (got   (tma-factors count)))
  (test "tma-factors" count want got))

(let* ((count 2)
       (want  '(1 1))
       (got   (tma-factors count)))
  (test "tma-factors" count want got))

(let* ((count 3)
       (want  '(1 2 1))
       (got   (tma-factors count)))
  (test "tma-factors" count want got))

(let* ((count 4)
       (want  '(1 2 2 1))
       (got   (tma-factors count)))
  (test "tma-factors" count want got))

(let* ((count 5)
       (want  '(1 2 3 2 1))
       (got   (tma-factors count)))
  (test "tma-factors" count want got))

(let* ((count 6)
       (want  '(1 2 3 3 2 1))
       (got   (tma-factors count)))
  (test "tma-factors" count want got))

;;
;; tma-calc-proc
;;

(let* ((count 4)
       (data  '( 0  0   0   0   0   0   0   0))
       (want  '(#f #f 0.0 0.0 0.0 0.0 0.0 0.0))
       (proc  (tma-calc-proc count))
       (got   (map-in-order proc data)))
  (test "tma-calc-proc" (list count data) want got))

(let* ((count 4)
       (data  '( 1  1   1   1   1   1   1   1))
       (want  '(#f #f 1.0 1.0 1.0 1.0 1.0 1.0))
       (proc  (tma-calc-proc count))
       (got   (map-in-order proc data)))
  (test "tma-calc-proc" (list count data) want got))

(let* ((count 4)
       (data  '( 0  0   0  12   0   0   0   0   0))
       (want  '(#f #f 0.0 2.0 4.0 4.0 2.0 0.0 0.0))
       (proc  (tma-calc-proc count))
       (got   (map-in-order proc data)))
  (test "tma-calc-proc" (list count data) want got))

(let* ((count  5)
       (data '( 0  0  0   0   0   0   0   0   0))
       (want '(#f #f #f 0.0 0.0 0.0 0.0 0.0 0.0))
       (proc  (tma-calc-proc count))
       (got   (map-in-order proc data)))
  (test "tma-calc-proc" (list count data) want got))

(let* ((count 5)
       (data  '( 1  1  1   1   1   1   1   1   1))
       (want  '(#f #f #f 1.0 1.0 1.0 1.0 1.0 1.0))
       (proc  (tma-calc-proc count))
       (got   (map-in-order proc data)))
  (test "tma-calc-proc" (list count data) want got))

(let* ((count 5)
       (data  '( 0  0  0   0  18   0   0   0   0   0   0))
       (want  '(#f #f #f 0.0 2.0 4.0 6.0 4.0 2.0 0.0 0.0))
       (proc  (tma-calc-proc count))
       (got   (map-in-order proc data)))
  (test "tma-calc-proc" (list count data) want got))


(let* ((count 3)
       (data  '( 0   0   8   0   0   0   0))
       (want  '(#f 0.0 2.0 4.0 2.0 0.0 0.0))
       (proc  (tma-calc-proc count))
       (got   (map-in-order proc data)))
  (test "tma-calc-proc" (list count data) want got))

(let* ((count 2)
       (data  '( 0   0   8   0   0   0))
       (want  '(#f 0.0 4.0 4.0 0.0 0.0))
       (proc  (tma-calc-proc count))
       (got   (map-in-order proc data)))
  (test "tma-calc-proc" (list count data) want got))

(let* ((count 1)
       (data  '(  0   8   0   0))
       (want  '(0.0 8.0 0.0 0.0))
       (proc  (tma-calc-proc count))
       (got   (map-in-order proc data)))
  (test "tma-calc-proc" (list count data) want got))


(tests-end)
