;; Exercise tocom.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; string-trim-zero-decimals
;;

(define string-trim-zero-decimals (@@ (chart tocom) string-trim-zero-decimals))

(for-each (lambda (elem)
	    (let* ((str  (first elem))
		   (want (second elem))
		   (got  (string-trim-zero-decimals str)))
	      (test "string-trim-zero-decimals" str want got)))

	  '(("123"    "123")
	    ("100"    "100")
	    ("100."   "100.")
	    ("100.50" "100.5")
	    ("100.05" "100.05")))

;;
;; call-with-string-in-file
;;

(define call-with-string-in-file (@@ (chart tocom) call-with-string-in-file))

(let* ((str     "hello")
       (want    #t)
       (name    #f)
       (got-str (call-with-string-in-file str
		  (lambda (filename)
		    (call-with-input-file filename read-string-to-eof))))
       (got     (and (not (file-exists? name))
		     (equal? got-str str))))
  (test "call-with-string-in-file" str want got))

(let* ((str     "hello")
       (want    #t)
       (name    #f)
       (got-str #f)
       (got     #f))
  (catch 'foo
    (lambda ()
      (call-with-string-in-file str
	(lambda (filename)
	  (set! name filename)
	  (set! got-str (call-with-input-file filename read-string-to-eof))
	  (throw 'foo))))
    noop)
  (set! got (and (not (file-exists? name))
		 (equal? got-str str)))
  (test "call-with-string-in-file" str want got))


(tests-end)
