;; Test trendscore.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart trendscore))


;;
;; trendscore-calc-proc
;;

(for-each (lambda (elem)
	    (let* ((initial (first elem))
		   (proc    (trendscore-calc-proc initial))
		   (data    (second elem))
		   (want    (third elem))
		   (got     (map-in-order proc data)))
	      (test "trendscore-calc-proc" (list initial data) want got)))
	  `((()
	     (10 20 30 40 50 60 70 80 90 100
		 -1 -2 -3 -4 -5 -6 -7 -8 -9 -10
		 40 10)
	     (#f #f #f #f #f #f #f #f #f #f
		 #f #f #f #f #f #f #f #f #f #f
		 ,(- 4 6) ,(- 1 9)))

	    ((10 20 30 40 50 60 70 80 90 100
		 -1 -2 -3 -4 -5 -6 -7 -8 -9 -10)
	     (40 10)
	     (,(- 4 6) ,(- 1 9)))))


(tests-end)
