;; Exercise ulcer.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart ulcer))


;;
;; ulcer-calc
;;

(let* ((lst  '())
       (want 0)
       (got  (ulcer-calc lst)))
  (test "ulcer-calc" lst want got))

(let* ((lst  '(10))
       (want 0.0)
       (got  (ulcer-calc lst)))
  (test "ulcer-calc" lst want got))

(let* ((lst  '(10 11 12 13))
       (want 0.0)
       (got  (ulcer-calc lst)))
  (test "ulcer-calc" lst want got))

(let* ((lst  '(10 8 10 11))   ;; (0 + 20^2 + 0 + 0) / 4 = 400/4 = 100
       (want 10.0)
       (got  (ulcer-calc lst)))
  (test "ulcer-calc" lst want got))

;; (0 + 10^2 + 20^2 + 20^2) / 4 = 900/4 = 225, sqrt==15
(let* ((lst  '(1000 900 800 800))
       (want 15.0)
       (got  (ulcer-calc lst)))
  (test "ulcer-calc" lst want got))

;; (0 + 3^2 + 0 + 4^2) / 4 = 25/4 = 6.25, sqrt = 2.5
(let* ((lst  '(1000 970 2000 1920))
       (want 2.5)
       (got  (ulcer-calc lst)))
  (test "ulcer-calc" lst want got))

(let* ((lst  '(0 0 0 0 0))
       (want 0.0)
       (got  (ulcer-calc lst)))
  (test "ulcer-calc" lst want got))

(let* ((lst  '(-2 -1 0 1))
       (want 0.0)
       (got  (ulcer-calc lst)))
  (test "ulcer-calc" lst want got))





(tests-end)
