;; Exercise vhf.scm.

;; Copyright 2006, 2007, 2009 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart vhf))


;;
;; vhf-calc-proc
;;

(define (try count data want)
  (let* ((vhf  (vhf-calc-proc count))
	 (got  (map-in-order vhf data)))
    (test "vhf-series" (list count data) want got)))

(try 3
     '( 1  2   3   4   5   6   7   8)
     '(#f #f 1.0 1.0 1.0 1.0 1.0 1.0))

(try 3
     '( 1  2   2   1   1)
     '(#f #f 1.0 1.0 1.0))

(try 3
     '( 1  2   1   2   1   2   1)
     '(#f #f 0.5 0.5 0.5 0.5 0.5))

(try 2
     '( 1   2   1   2   1   2   1)
     '(#f 1.0 1.0 1.0 1.0 1.0 1.0))

(try 5
     '( 1  2  3   4    3   2    1    2   3   2   3    2    3)
     '(#f #f #f 1.0 0.75 0.5 0.75 0.75 0.5 0.5 0.5 0.25 0.25))


(tests-end)
