;; Test vscale.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(need-gtk)


;;
;; round-up-multiple
;;

(define round-up-multiple (@@ (chart vscale) round-up-multiple))

(let* ((n    0)
       (d    3)
       (want 0)
       (got  (round-up-multiple n d)))
  (test "round-up-multiple" (list n d) want got))

(let* ((n    1)
       (d    3)
       (want 3)
       (got  (round-up-multiple n d)))
  (test "round-up-multiple" (list n d) want got))

(let* ((n    2)
       (d    3)
       (want 3)
       (got  (round-up-multiple n d)))
  (test "round-up-multiple" (list n d) want got))

(let* ((n    3)
       (d    3)
       (want 3)
       (got  (round-up-multiple n d)))
  (test "round-up-multiple" (list n d) want got))

(let* ((n    5)
       (d    3)
       (want 6)
       (got  (round-up-multiple n d)))
  (test "round-up-multiple" (list n d) want got))

(let* ((n    -1)
       (d    3)
       (want 0)
       (got  (round-up-multiple n d)))
  (test "round-up-multiple" (list n d) want got))

(let* ((n    -2)
       (d    3)
       (want 0)
       (got  (round-up-multiple n d)))
  (test "round-up-multiple" (list n d) want got))

(let* ((n    -3)
       (d    3)
       (want -3)
       (got  (round-up-multiple n d)))
  (test "round-up-multiple" (list n d) want got))

(let* ((n    -5)
       (d    3)
       (want -3)
       (got  (round-up-multiple n d)))
  (test "round-up-multiple" (list n d) want got))



(tests-end)
