;; Test WCE functions.

;; Copyright 2006, 2007, 2009 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")


;;
;; source-help
;;

;; (let* ((symbol "RS.WCE")
;;        (want   (_ "CONTEXT(manual-node): Winnipeg Commodity Exchange"))
;;        (got    (source-help symbol)))
;;   (test "source-help" symbol want got))

;;
;; wce-hist-date-range
;;

(define wce-hist-date-range (@@ (chart wce) wce-hist-date-range))

(let* ((str "Nov 1980 - Jul 1993")
       (want (list (ymd->tdate 1980 11 1) (ymd->tdate 1993 7 30)))
       (got  (wce-hist-date-range str)))
  (test "available-tdate" str want got))

(let ((old-tdate-today tdate-today))
  (set! tdate-today (lambda (zone) 123))

  (let* ((str "Jan 5, 1970 - present")
	 (want '(0 124))
	 (got  (wce-hist-date-range str)))
    (test "available-tdate" str want got))

  (set! tdate-today old-tdate-today))

(tests-end)
