;; Exercise williams-accdist.scm.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart williams-accdist))


;;
;; williams-accdist-func
;;

(let* ((array #2((x  x  x 10 x)
		 (x 14 10 12 1000)))
       (want  2)
       (got   (williams-accdist-func array 0 1)))
  (test "williams-accdist-func" array want got))

(let* ((array #2((x  x  x 10 x)
		 (x 14 10 11 1000)))
       (want  1)
       (got   (williams-accdist-func array 0 1)))
  (test "williams-accdist-func" array want got))

(let* ((array #2((x  x  x 10 x)
		 (x 14 11 11 1000)))
       (want  1)
       (got   (williams-accdist-func array 0 1)))
  (test "williams-accdist-func" array want got))

(let* ((array #2((x  x  x 11 x)
		 (x 14 10 10 1000)))
       (want  -4)
       (got   (williams-accdist-func array 0 1)))
  (test "williams-accdist-func" array want got))

(let* ((array #2((x  x  x 14 x)
		 (x 11 10 10 1000)))
       (want  -4)
       (got   (williams-accdist-func array 0 1)))
  (test "williams-accdist-func" array want got))


(tests-end)
