;; Exercise wma.scm.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart wma))


;;
;; dot-product
;;

(define dot-product (@@ (chart wma) dot-product))

(let* ((x    '(1 2))
       (y    '(3 4))
       (want 11)
       (got  (dot-product x y)))
  (test "dot-product" (list x y) want got))


;;
;; triangular
;;

(define triangular (@@ (chart wma) triangular))

(let* ((n    3)
       (want 6)
       (got  (triangular n)))
  (test "triangular" n want got))


;;
;; wma-calc-proc
;;

(let* ((proc (wma-calc-proc 3 '()))
       (data '(6.0 6.0 6.0 24.0 24.0 24.0 24.0  6.0 6.0 6.0 6.0))
       (want '( #f 6.0 6.0 15.0 21.0 24.0 24.0 15.0 9.0 6.0 6.0))
       (got  (map-in-order proc data)))
  (test "wma-calc-proc" data want got))

(let* ((proc (wma-calc-proc 3 '(6.0)))
       (data '(6.0 6.0 24.0 24.0 24.0 24.0  6.0 6.0 6.0 6.0))
       (want '(6.0 6.0 15.0 21.0 24.0 24.0 15.0 9.0 6.0 6.0))
       (got  (map-in-order proc data)))
  (test "wma-calc-proc" data want got))

(let* ((proc (wma-calc-proc 3 '(6.0 6.0)))
       (data '(6.0 24.0 24.0 24.0 24.0  6.0 6.0 6.0 6.0))
       (want '(6.0 15.0 21.0 24.0 24.0 15.0 9.0 6.0 6.0))
       (got  (map-in-order proc data)))
  (test "wma-calc-proc" data want got))

(let* ((proc (wma-calc-proc 4 '(1 2 3)))
       (want (/ (+ (square 1) (square 2) (square 3) (square 4))
		(+ 1.0 2 3 4)))
       (got  (proc 4)))
  (test "wma-calc-proc" '(1 2 3 4) want got))


(tests-end)
