;; Test xls.scm functions.

;; Copyright 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart xls))


;;
;; msdate->adate
;;

(for-each (lambda (elem)
	    (let* ((msdate (first elem))
		   (want   (second elem))
		   (got    (msdate->adate msdate)))
	      (test "msdate->adate" msdate want got)))

	  `((0       ,(ymd->adate 1899 12 31)) ;; 31 Dec 1899
	    (36892   ,(ymd->adate 2001 1 1))   ;; 1 Jan 2001
	    (39084.0 ,(ymd->adate 2007 1 2))   ;; 2 Jan 2007
	    ))

(tests-end)
