;; Stock Exchange of Thailand setups.

;; Copyright 2005, 2006, 2007, 2008 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart thailand)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc))


;; ^THDOW
;; ^THDOWD
;; ^DWTH
;; ^DWTHD
;; ^DWTHT
;; ^DWTHTD
;;
;; old ^SETI seems gone
;;
(define (yahoo-index-symbol-thailand? symbol)
  (or (string-prefix? "^TH" symbol)
      (string-prefix? "^DWTH" symbol)))

(define-public timezone-bangkok
  (make-procedure-with-cache-0
   (lambda ()
     (timezone-choose (_ "Bangkok")
		      '("Asia/Bangkok"
			"ICT-7") ;; no daylight savings
		      "ICT-7"))))

(symbol-timezone! yahoo-index-symbol-thailand? (_ "Bangkok") timezone-bangkok)


;;-----------------------------------------------------------------------------
;; weblink - only the home page for now ...
;;

(weblink-handler! yahoo-index-symbol-thailand?
  (lambda (symbol)
    (list (_ "_SET Home Page")
	  (_ "Open web browser at the Stock Exchange of Thailand home page")
	  (lang-select '(("th" "http://www.set.or.th")
			 ("en" "http://www.set.or.th/en/index.html"))))))


;;-----------------------------------------------------------------------------
;; defunct bits

;; gone from yahoo as of Mar 2007
;;(symbol-setups! ".BK"    '(chart thailand))
;;(symbol-setups! "^SET"    '(chart thailand))

;; @item
;; @item @nisamp{.BK} @tab Thailand
;; @cindex @code{.BK}
;; @cindex Stock Exchange of Thailand
;; @cindex SET
;; @cindex Thailand
;; @tab Stock Exchange of Thailand (SET) @*
;; @uref{http://www.set.or.th/en/index.html}

;; ;; ^SETI
;; (define (yahoo-index-symbol-thailand? symbol)
;;   (string-prefix? "^SET" symbol))

;; ;; ^SETI
;; (define (yahoo-index-symbol-thailand? symbol)
;;   (string-prefix? "^SET" symbol))

;; (symbol-timezone! thailand-symbol? (_ "Bangkok") timezone-bangkok)

;; ;; not sure what quote delay
;; (yahoo-symbol-add! thailand-symbol?)
