;; Tokyo Stock Exchange (TSE) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart tokyo)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc))


;; ^N225 (and not ^NZ50 etc in newzealand.scm)
(define (yahoo-index-symbol-japan? symbol) 
  (string-prefix? "^N2" symbol))

(symbol-timezone! yahoo-index-symbol-japan? (_ "Tokyo") timezone-tokyo)


;;-----------------------------------------------------------------------------
;; web link - only the home page for now ...
;;

(weblink-handler! yahoo-index-symbol-japan?
  (lambda (symbol)
    (list (_ "_Tokyo Stock Exchange Home Page")
	  (_ "Open web browser at the Tokyo Stock Exchange home page")
	  (lang-select '(("ja" "http://www.tse.or.jp")
			 ("en" "http://www.tse.or.jp/english/"))))))


;;-----------------------------------------------------------------------------
;; web link - TSE company info
;;
;; Eg. in english
;;     http://quote.tse.or.jp/tse/quote.cgi?F=listing/EDetail1&MKTN=T&QCODE=2001
;; and japanese
;;     http://quote.tse.or.jp/tse/quote.cgi?F=listing/Jdetail1&MKTN=T&QCODE=2001
;;

;; no tokyo symbols as such yet ...
;;
;; (weblink-handler! tokyo-symbol?
;;   (lambda (symbol)
;;     (list (_ "TSE _Company Information")
;; 	  (_ "Open web browser at the Tokyo Stock Exchange page for this company")
;; 	  (string-append "http://quote.tse.or.jp/tse/quote.cgi?F=listing/"
;; 			 (lang-select '(("ja" "J")
;; 					("en" "E")))
;; 			 "Detail1&MKTN=T&QCODE="
;; 			 (chart-symbol-sans-dot symbol)))))
