/* Copyright 2006, 2008 Kevin Ryde

   This file is part of Chart.

   Chart is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 3, or (at your option) any later
   version.

   Chart is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <stdio.h>
#include <gtk/gtk.h>

GtkObject *oldadj, *newadj;
GtkWidget *hscrollbar;

void
activate (GtkWidget *widget, gpointer data)
{
  printf ("activate\n");
}

int
main (int argc, char *argv[])
{
  GtkWidget *toplevel, *about;

  putenv ("DISPLAY=:0");
  gtk_init (&argc, &argv);

  gtk_init(&argc, &argv);
  toplevel = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  about = gtk_about_dialog_new ();
  gtk_about_dialog_set_name (GTK_ABOUT_DIALOG(about), "Chart");
  gtk_about_dialog_set_version (GTK_ABOUT_DIALOG(about), "20");

  gtk_about_dialog_set_copyright (GTK_ABOUT_DIALOG(about),
                                  "Copyright 2006");

  gtk_about_dialog_set_license (GTK_ABOUT_DIALOG(about),
                                "Long licence\nstring.");

  gtk_about_dialog_set_website (GTK_ABOUT_DIALOG(about),
                                "http://www.geocities.com/user42_kevin/chart/index.html");

  gtk_about_dialog_set_comments (GTK_ABOUT_DIALOG(about),
                                 "This is\na comment.");

  {
    static const gchar *authors[] = { "Kevin Ryde", NULL };
    gtk_about_dialog_set_authors (GTK_ABOUT_DIALOG(about), authors);
  }


  {
    GdkPixbuf *pixbuf = gdk_pixbuf_new_from_file ("/home/gg/chart/chart.xpm",
                                                  NULL);
    gtk_about_dialog_set_logo (GTK_ABOUT_DIALOG(about), pixbuf);
  }

  gtk_widget_show (about);

  gtk_widget_show_all (toplevel);
  gtk_main ();
  return 0;
}
