;; Test CommSec functions.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(load "tests.scm")
(use-modules (chart commsec))

;;
;; commsec-available-tdate
;;

(let ((ymdhm  '(2005 1 6  22 0))) ;; Thursday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 5))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 6  23 0))) ;; Thursday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 7  22 0))) ;; Friday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 6))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 7  23 0))) ;; Friday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 8  22 0))) ;; Saturday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 8  23 0))) ;; Saturday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 9  22 0))) ;; Sunday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 9  23 0))) ;; Sunday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 10  22 0))) ;; Monday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 7))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 10  23 0))) ;; Monday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 10))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 11  22 0))) ;; Tuesday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 10))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 11  23 0))) ;; Tuesday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 11))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 12  22 0))) ;; Wednesday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 11))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(let ((ymdhm  '(2005 1 12  23 0))) ;; Wednesday
  (apply fake-localtime-ymdhm! (timezone-sydney) ymdhm)
  (let ((want (ymd->tdate 2005 1 12))
	(got  (commsec-available-tdate)))
    (test "commsec-available-tdate" ymdhm want got)))

(tests-end)
