/* Copyright 2006, 2008 Kevin Ryde

   This file is part of Chart.

   Chart is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 3, or (at your option) any later
   version.

   Chart is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */


#include <stdio.h>
#include <ctype.h>

#include <curses.h>
#include <term.h>

void
pr (char *s)
{
  int c;
  if (s == NULL)
    {
      printf ("NULL\n");
      return;
    }
  for ( ; *s != '\0'; s++)
    {
      c = (int) (unsigned char) *s;
      if (isprint (c))
        putchar (c);
      else
        printf ("\\x%02X", c);
    }
  printf ("\n");
}

int
pc (int c)
{
  if (isprint (c))
    putchar (c);
  else
    printf ("\\x%02X", c);
  return c;
}

int
main (void)
{
  char *str, *exp;

  {
    int ret, err;
    ret = setupterm (NULL, 1, &err);
    if (ret != OK)
      printf ("ret %d err %d\n", ret, err);
  }
  str = tigetstr ("setaf");
  pr (str);

  exp = tparm (str, 2);
  pr (exp);

  tputs (exp, 1, pc);
  printf ("\n");

/*   { */
/*     int i; */
/*     for (i = 0; boolnames[i] != NULL; i++) */
/*       { */
/*         printf ("%s %s %s\n", boolnames[i], boolcodes[i], boolfnames[i]); */
/*       } */
/*   } */

  return 0;
}
    
