;; Copyright 2007, 2008 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 2, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License along
;; with Chart; see the file COPYING.  If not, write to the Free Software
;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
;; USA.



;;  

(define sqrt-pi (sqrt 3.14192))

(define (white-le-340 n)
  (* (/ (- n 0.5)  n)
     (/ (gamma (* 0.5 (1- n)))  (* sqrt-pi (gamma (* 0.5 n))))
     (apply + (map! (lambda (i)
		      (sqrt (/ (- n i) i)))
		    (iota (1- n) 1.0)))))

(define (white-gt-340 n)
  (* (/ (- n 0.5)  n)
     (/ (sqrt (* n pi 0.5)))
     (apply + (map! (lambda (i)
		      (sqrt (/ (- n i) i)))
		    (iota (1- n) 1.0)))))

(define (white n)
  (if (<= n 340)
      (white-le-340 n)
      (white-gt-340 n)))
