;; Copyright 2005, 2007, 2008 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 2, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License along
;; with Chart; see the file COPYING.  If not, write to the Free Software
;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
;; USA.


(use-modules (chart database)
	     (chart misc))

(set! *random-state* (seed->random-state (current-time)))

(define hi (tdate-today))
(define lo (- hi 200))
(define array (make-array #f (list lo hi) '(0 4)))

;; LO to HI inclusive 
(define (random:int lo hi)
  (+ lo (random (- hi lo -1))))

(define (random:range lo hi)
  (let ((range (- hi lo)))
    (if (zero? range)
	lo
	(+ lo (random range)))))

(let ((prev 500))
  (do ((i lo (1+ i)))
      ((> i hi))

    (let* ((x (round-exact (* prev (random:range 0.97 1.01))))
	   (y (round-exact (* prev (random:range 1.01 1.03))))
	   (l (min x y))
	   (h (max x y))
	   
	   (a (max (random:range l h) (random:range l h)))
	   (b (min (random:range l h) (random:range l h)))
	   (t (= 0 (random 2)))
	   (o (if t a b))
	   (c (if t b a)))

      (array-set! array o i 0)
      (array-set! array h i 1)
      (array-set! array l i 2)
      (array-set! array c i 3)
      (array-set! array (random:int 100000 180000) i 4))

    (set! prev (round-exact (* prev (random:range 0.97 1.03))))))

(database-write-series (series-new #:symbol   "FOO.BAR"
				   #:name     "Foo Bar Widgets Pty Ltd"
				   #:array    array
				   #:decimals 2))
