;; Vienna Stock Exchange (Wiener Borse) setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart vienna)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (vienna-symbol? symbol)
  (string-suffix? ".VI" symbol))

;; ^ATX
;;
;; must avoid ^ATLI and similar in australia.scm
;;
(define (yahoo-index-symbol-vienna? symbol) 
  (string-prefix? "^ATX" symbol))

(symbol-timezone! vienna-symbol?             (_ "Vienna") timezone-europe-cet)
(symbol-timezone! yahoo-index-symbol-vienna? (_ "Vienna") timezone-europe-cet)
(yahoo-quote-delay! vienna-symbol? 15)


;; only the home page for now ...
;;
;; Info urls use isin, so would have to look that up somehow ...
;;
(weblink-handler! (list vienna-symbol? yahoo-index-symbol-vienna?)
  (lambda (symbol)
    (list (_ "_Vienna Stock Exchange Home Page")
	  (_ "Open web browser at the Vienna Stock Exchange home page")
	  (lang-select '(("de" "http://www.wienerborse.at/")
			 ("en" "http://en.wienerborse.at/"))))))
