;; Virt-X exchange setups.

;; Copyright 2005, 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart virtx)
  #:use-module (srfi srfi-13)
  #:use-module (chart download)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


(define-public (virtx-symbol? symbol)
  (string-suffix? ".VX" symbol))

(symbol-timezone! virtx-symbol? (_ "Switzerland") timezone-europe-cet)

;; FIXME: what delay for virtx?  Guess same 30 minutes as SWX.
(yahoo-quote-delay! virtx-symbol? 30)


;; virt-x.com company info pages are based on ISIN codes, not the symbol,
;; would need to extract that to do web links

;; only the home page for now ...
;;
(weblink-handler! virtx-symbol?
  (lambda (symbol)
    (list (_ "_Virt-X Home Page")
	  (_ "Open web browser at the Virt-X Stock Exchange home page")
	  "http://www.virt-x.com/index.html")))
