;; Yahoo currencies setups.

;; Copyright 2006, 2007 Kevin Ryde

;; This file is part of Chart.
;;
;; Chart is free software; you can redistribute it and/or modify it under
;; the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; Chart is distributed in the hope that it will be useful, but WITHOUT ANY
;; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;; details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chart yahoo-currencies)
  #:use-module (srfi srfi-13)
  #:use-module (chart misc)
  #:use-module (chart yahoo))


;; http://help.yahoo.com/help/us/fin/quote/quote-02.html
;;
;; eg. AUDUSD=X
;;     XAUUSD=X   gold in US$
;;     XPTUSD=X   platinum in US$
;;
(define-public (yahoo-currency-symbol? symbol)
  (string-suffix? "=X" symbol))

(symbol-timezone! yahoo-currency-symbol? (_ "Local") timezone-local)

;; suspect no delay, not quite sure
(yahoo-quote-delay! yahoo-currency-symbol? 0)
